import * as i0 from '@angular/core';
import { Component, ContentChildren, NgModule, Input, Injectable, Pipe, EventEmitter, Output, Directive, HostBinding, Host, SkipSelf, HostListener, forwardRef, PLATFORM_ID, Inject, ContentChild, TemplateRef, ViewChild, Optional, ViewChildren, InjectionToken, Injector } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule, DOCUMENT } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { SlideUpDownAnimation, FadeInOutAnimation, CarouselSlideAnimation, ColorTransitionAnimation } from '@mintplayer/ng-animations';
import { Subject, BehaviorSubject, map, takeUntil, filter, take, Observable, combineLatest } from 'rxjs';
import { map as map$1, takeUntil as takeUntil$1, take as take$1 } from 'rxjs/operators';
import * as i1$1 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';
import { TemplatePortal, ComponentPortal } from '@angular/cdk/portal';
import '@mintplayer/ng-pagination';
import * as i1$2 from '@mintplayer/ng-click-outside';
import { ClickOutsideDirective, ClickOutsideModule } from '@mintplayer/ng-click-outside';
import { FocusOnLoadModule } from '@mintplayer/ng-focus-on-load';
import { RouterModule, ROUTER_CONFIGURATION } from '@angular/router';
import * as i3 from '@angular/forms';
import { FormsModule } from '@angular/forms';

class BsAccordionTabComponent {
    constructor(accordion) {
        this.accordion = accordion;
    }
    ngOnInit() {
    }
    headerClicked(event) {
        if (this.accordion.activeTab === this) {
            this.accordion.activeTab = null;
        }
        else {
            this.accordion.activeTab = this;
        }
    }
}
BsAccordionTabComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionTabComponent, deps: [{ token: BsAccordionComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAccordionTabComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsAccordionTabComponent, selector: "bs-accordion-tab", ngImport: i0, template: "<div class=\"card\">\n    <ng-content select=\"bs-accordion-tab-header\"></ng-content>\n    <div class=\"card-block overflow-hidden\" [@slideUpDown] *ngIf=\"accordion.activeTab === this\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card,.card-header,.card-block{border-radius:0}.card{margin-bottom:-1px}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionTabComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion-tab', animations: [SlideUpDownAnimation], template: "<div class=\"card\">\n    <ng-content select=\"bs-accordion-tab-header\"></ng-content>\n    <div class=\"card-block overflow-hidden\" [@slideUpDown] *ngIf=\"accordion.activeTab === this\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card,.card-header,.card-block{border-radius:0}.card{margin-bottom:-1px}\n"] }]
        }], ctorParameters: function () { return [{ type: BsAccordionComponent }]; } });

class BsAccordionComponent {
    constructor() {
        this.activeTab = null;
    }
    ngOnInit() {
    }
}
BsAccordionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsAccordionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsAccordionComponent, selector: "bs-accordion", queries: [{ propertyName: "tabPages", predicate: BsAccordionTabComponent }], ngImport: i0, template: "<ng-content></ng-content>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion', template: "<ng-content></ng-content>", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { tabPages: [{
                type: ContentChildren,
                args: [BsAccordionTabComponent]
            }] } });

class BsAccordionTabHeaderComponent {
    constructor(accordionTab, accordion) {
        this.accordionTab = accordionTab;
        this.accordion = accordion;
    }
    ngOnInit() {
    }
    headerClicked(event) {
        event.preventDefault();
        if (this.accordion.activeTab === this.accordionTab) {
            this.accordion.activeTab = null;
        }
        else {
            this.accordion.activeTab = this.accordionTab;
        }
    }
    foo(event) {
        event.preventDefault();
    }
}
BsAccordionTabHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionTabHeaderComponent, deps: [{ token: BsAccordionTabComponent }, { token: BsAccordionComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAccordionTabHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsAccordionTabHeaderComponent, selector: "bs-accordion-tab-header", ngImport: i0, template: "<div class=\"card-header cursor-pointer\" (click)=\"headerClicked($event)\" (contextmenu)=\"foo($event)\">\n    <ng-content></ng-content>\n</div>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionTabHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-accordion-tab-header', template: "<div class=\"card-header cursor-pointer\" (click)=\"headerClicked($event)\" (contextmenu)=\"foo($event)\">\n    <ng-content></ng-content>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: BsAccordionTabComponent }, { type: BsAccordionComponent }]; } });

class BsAccordionModule {
}
BsAccordionModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsAccordionModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionModule, declarations: [BsAccordionComponent,
        BsAccordionTabComponent,
        BsAccordionTabHeaderComponent], imports: [CommonModule,
        BrowserAnimationsModule], exports: [BsAccordionComponent,
        BsAccordionTabComponent,
        BsAccordionTabHeaderComponent] });
BsAccordionModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionModule, imports: [[
            CommonModule,
            BrowserAnimationsModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsAccordionComponent,
                        BsAccordionTabComponent,
                        BsAccordionTabHeaderComponent
                    ],
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule
                    ],
                    exports: [
                        BsAccordionComponent,
                        BsAccordionTabComponent,
                        BsAccordionTabHeaderComponent
                    ]
                }]
        }] });

var Color;
(function (Color) {
    Color[Color["primary"] = 0] = "primary";
    Color[Color["secondary"] = 1] = "secondary";
    Color[Color["success"] = 2] = "success";
    Color[Color["danger"] = 3] = "danger";
    Color[Color["warning"] = 4] = "warning";
    Color[Color["info"] = 5] = "info";
    Color[Color["light"] = 6] = "light";
    Color[Color["dark"] = 7] = "dark";
    Color[Color["body"] = 8] = "body";
    Color[Color["white"] = 9] = "white";
    Color[Color["transparent"] = 10] = "transparent";
})(Color || (Color = {}));

var Position;
(function (Position) {
    Position[Position["top"] = 0] = "top";
    Position[Position["left"] = 1] = "left";
    Position[Position["bottom"] = 2] = "bottom";
    Position[Position["right"] = 3] = "right";
})(Position || (Position = {}));

class BsAlertComponent {
    constructor() {
        this.type = Color.primary;
        this.colors = Color;
        this.isVisible = true;
    }
    ngOnInit() {
    }
}
BsAlertComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsAlertComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsAlertComponent, selector: "bs-alert", inputs: { type: "type" }, ngImport: i0, template: "<div class=\"mb-3 overflow-hidden\" *ngIf=\"isVisible\" [@fadeInOut]>\n    <div class=\"alert mb-0\" [ngClass]=\"'alert-' + colors[type]\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: ["::ng-deep .alert .btn{bottom:0;display:inline-flex;align-items:center}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], animations: [FadeInOutAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-alert', animations: [FadeInOutAnimation], template: "<div class=\"mb-3 overflow-hidden\" *ngIf=\"isVisible\" [@fadeInOut]>\n    <div class=\"alert mb-0\" [ngClass]=\"'alert-' + colors[type]\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: ["::ng-deep .alert .btn{bottom:0;display:inline-flex;align-items:center}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { type: [{
                type: Input
            }] } });

class BsAlertCloseComponent {
    constructor(alert) {
        this.alert = alert;
    }
    ngOnInit() {
    }
    closeAlert() {
        this.alert.isVisible = false;
    }
}
BsAlertCloseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertCloseComponent, deps: [{ token: BsAlertComponent }], target: i0.ɵɵFactoryTarget.Component });
BsAlertCloseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsAlertCloseComponent, selector: "bs-alert-close", ngImport: i0, template: "<button class=\"btn float-end\" (click)=\"closeAlert()\">\n    <span class=\"text-dark\">\u00D7</span>\n</button>", styles: ["button{top:0;right:0;border:0;position:absolute;padding:.75rem 1.25rem!important;background:transparent}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertCloseComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-alert-close', template: "<button class=\"btn float-end\" (click)=\"closeAlert()\">\n    <span class=\"text-dark\">\u00D7</span>\n</button>", styles: ["button{top:0;right:0;border:0;position:absolute;padding:.75rem 1.25rem!important;background:transparent}\n"] }]
        }], ctorParameters: function () { return [{ type: BsAlertComponent }]; } });

class BsAlertModule {
}
BsAlertModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsAlertModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertModule, declarations: [BsAlertComponent,
        BsAlertCloseComponent], imports: [CommonModule], exports: [BsAlertComponent,
        BsAlertCloseComponent] });
BsAlertModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsAlertModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsAlertComponent,
                        BsAlertCloseComponent
                    ],
                    exports: [
                        BsAlertComponent,
                        BsAlertCloseComponent
                    ]
                }]
        }] });

class BsCalendarMonthService {
    getWeeks(month) {
        const firstAndLast = this.getFirstAndLastDayOfMonth(month);
        const days = this.dateDiff(firstAndLast.first, firstAndLast.last) + 1;
        const allDays = [
            ...this.generateList(this.dayOfWeekMondayBased(firstAndLast.first)).map(d => null),
            ...this.generateList(days).map(d => {
                return {
                    date: new Date(firstAndLast.first.getFullYear(), firstAndLast.first.getMonth(), firstAndLast.first.getDate() + d),
                    dayOfMonth: d + 1,
                };
            }),
            ...this.generateList(6 - this.dayOfWeekMondayBased(firstAndLast.last)).map(d => null),
        ];
        const weeks = this.chunk(allDays, 7);
        const weeksMapped = weeks.map((w, i) => {
            return {
                number: this.weekOfYear(new Date(month.getFullYear(), month.getMonth(), w.find(d => d !== null)?.dayOfMonth)),
                week: w
            };
        });
        return weeksMapped;
    }
    generateList(count) {
        return [...Array(count).keys()];
    }
    dayOfWeekMondayBased(date) {
        const d = date.getDay() - 1;
        if (d < 0) {
            return 6;
        }
        else {
            return d;
        }
    }
    weekOfYear(date) {
        const dateClone = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
        dateClone.setUTCDate(dateClone.getUTCDate() + 4 - (dateClone.getUTCDay() || 7));
        const yearStart = new Date(Date.UTC(dateClone.getUTCFullYear(), 0, 1));
        const utcDiff = this.toUTC(dateClone) - this.toUTC(yearStart);
        return Math.ceil((utcDiff / (1000 * 60 * 60 * 24) + 1) / 7);
    }
    getFirstAndLastDayOfMonth(date) {
        return {
            first: new Date(date.getFullYear(), date.getMonth(), 1),
            last: new Date(date.getFullYear(), date.getMonth() + 1, 0)
        };
    }
    dateDiff(date1, date2) {
        const utc1 = this.toUTC(date1);
        const utc2 = this.toUTC(date2);
        const msPerDay = 1000 * 60 * 60 * 24;
        return Math.floor((utc2 - utc1) / msPerDay);
    }
    dayOfYear(date) {
        const start = new Date(date.getFullYear(), 0, 0);
        return this.dateDiff(start, date);
    }
    toUTC(date) {
        return Date.UTC(date.getFullYear(), date.getMonth(), date.getDate());
    }
    chunk(items, size) {
        const result = [];
        for (let i = 0; i < items.length; i += size) {
            result.push(items.slice(i, i + size));
        }
        return result;
    }
}
BsCalendarMonthService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarMonthService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
BsCalendarMonthService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarMonthService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarMonthService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class UcFirstPipe {
    transform(value, ...args) {
        return value[0].toUpperCase() + value.slice(1);
    }
}
UcFirstPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: UcFirstPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
UcFirstPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: UcFirstPipe, name: "ucFirst" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: UcFirstPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ucFirst'
                }]
        }] });

class MonthNamePipe {
    transform(date, ...args) {
        if (date) {
            return date.toLocaleString("default", { month: 'long' });
        }
        else {
            return '';
        }
    }
}
MonthNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: MonthNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonthNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: MonthNamePipe, name: "monthName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: MonthNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monthName'
                }]
        }] });

class BsCalendarComponent {
    constructor(calendarMonthService, ref) {
        this.calendarMonthService = calendarMonthService;
        this.ref = ref;
        this.destroyed$ = new Subject();
        //#region CurrentMonth
        this.currentMonth$ = new BehaviorSubject(new Date());
        this.currentMonthChange = new EventEmitter();
        //#endregion
        //#region SelectedDate
        this.selectedDate$ = new BehaviorSubject(new Date());
        this.selectedDateChange = new EventEmitter();
        //#endregion
        this.daysOfWeek = ['Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa', 'Su'];
        this.weeks$ = this.currentMonth$
            .pipe(map((month) => this.calendarMonthService.getWeeks(month)))
            .pipe(takeUntil(this.destroyed$));
        this.daysOfWeek$ = this.weeks$
            .pipe(filter((weeks) => weeks.length > 1))
            .pipe(map((weeks) => weeks[1].week))
            .pipe(map((week) => {
            const firstDay = week[0];
            if (firstDay) {
                return week.map((d) => {
                    const date = new Date(firstDay.date.getFullYear(), firstDay.date.getMonth(), d?.dayOfMonth);
                    return date.toLocaleString('default', { weekday: 'short' });
                });
            }
            else {
                return [];
            }
        }));
        this.selectedDate$.pipe(takeUntil(this.destroyed$)).subscribe((date) => {
            this.selectedDateChange.emit(date);
        });
        this.currentMonth$.pipe(takeUntil(this.destroyed$)).subscribe((month) => {
            this.currentMonthChange.emit(month);
        });
    }
    get currentMonth() {
        return this.currentMonth$.value;
    }
    set currentMonth(value) {
        this.currentMonth$.next(value);
    }
    get selectedDate() {
        return this.selectedDate$.value;
    }
    set selectedDate(value) {
        this.selectedDate$.next(value);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    previousMonth() {
        this.currentMonth$.pipe(take(1)).subscribe((month) => {
            this.currentMonth$.next(new Date(month.getFullYear(), month.getMonth() - 1, 1));
        });
        return false;
    }
    nextMonth() {
        this.currentMonth$.pipe(take(1)).subscribe((month) => {
            this.currentMonth$.next(new Date(month.getFullYear(), month.getMonth() + 1, 1));
        });
        return false;
    }
    isSameDate(date1, date2) {
        if (date1 === null && date2 === null)
            return true;
        if (date1 === null || date2 === null)
            return false;
        return (date1.getFullYear() === date2.getFullYear() &&
            date1.getMonth() === date2.getMonth() &&
            date1.getDate() === date2.getDate());
    }
    goto(day) {
        if (day) {
            this.selectedDate$.next(day.date);
        }
    }
}
BsCalendarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarComponent, deps: [{ token: BsCalendarMonthService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
BsCalendarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsCalendarComponent, selector: "bs-calendar", inputs: { currentMonth: "currentMonth", selectedDate: "selectedDate" }, outputs: { currentMonthChange: "currentMonthChange", selectedDateChange: "selectedDateChange" }, ngImport: i0, template: "<table class=\"table w-auto mb-0\">\n    <tr>\n        <td>\n            <button class=\"btn btn-default\" (click)=\"previousMonth()\">\n                <i class=\"bi bi-chevron-left fw-bolder\"></i>\n            </button>\n        </td>\n        <td colspan=\"6\" class=\"fw-bolder\">\n            {{ currentMonth$ | async | monthName | ucFirst }}\n            {{ (currentMonth$ | async)?.getFullYear() }}\n        </td>\n        <td>\n            <button class=\"btn btn-default border-bottom-0\" (click)=\"nextMonth()\">\n                <i class=\"bi bi-chevron-right fw-bolder\"></i>\n            </button>\n        </td>\n    </tr>\n    <tr>\n        <th></th>\n        <th *ngFor=\"let dayOfWeek of daysOfWeek\">\n            {{ dayOfWeek }}\n        </th>\n    </tr>\n    <tr *ngFor=\"let week of (weeks$ | async)\">\n        <th>\n            {{ week.number }}\n        </th>\n        <td [class.selected]=\"day === null ? false : isSameDate(selectedDate$ | async, day.date)\" *ngFor=\"let day of week.week\" (click)=\"goto(day)\">\n            <span *ngIf=\"day !== null\">{{ day.dayOfMonth }}</span>\n        </td>\n    </tr>\n</table>", styles: ["table{border-collapse:collapse;border:1px solid rgba(0,0,0,.125);background:#fff}table td,table th{width:40px;height:40px;text-align:center}table td span,table th span{cursor:pointer;white-space:nowrap}table td.selected{background-color:#0d6efd;color:#fff}table th{background-color:#f8f9fa}table tr{border-top:none}table tr:first-child>td{border-bottom:1px solid rgba(0,0,0,.125)}table tr:nth-of-type(2)>th:not(:nth-of-type(1)){border-bottom:1px solid rgba(0,0,0,.125)}table tr:not(:nth-of-type(2))>th:nth-of-type(1){border-right:1px solid rgba(0,0,0,.125)}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "ucFirst": UcFirstPipe, "monthName": MonthNamePipe, "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-calendar', template: "<table class=\"table w-auto mb-0\">\n    <tr>\n        <td>\n            <button class=\"btn btn-default\" (click)=\"previousMonth()\">\n                <i class=\"bi bi-chevron-left fw-bolder\"></i>\n            </button>\n        </td>\n        <td colspan=\"6\" class=\"fw-bolder\">\n            {{ currentMonth$ | async | monthName | ucFirst }}\n            {{ (currentMonth$ | async)?.getFullYear() }}\n        </td>\n        <td>\n            <button class=\"btn btn-default border-bottom-0\" (click)=\"nextMonth()\">\n                <i class=\"bi bi-chevron-right fw-bolder\"></i>\n            </button>\n        </td>\n    </tr>\n    <tr>\n        <th></th>\n        <th *ngFor=\"let dayOfWeek of daysOfWeek\">\n            {{ dayOfWeek }}\n        </th>\n    </tr>\n    <tr *ngFor=\"let week of (weeks$ | async)\">\n        <th>\n            {{ week.number }}\n        </th>\n        <td [class.selected]=\"day === null ? false : isSameDate(selectedDate$ | async, day.date)\" *ngFor=\"let day of week.week\" (click)=\"goto(day)\">\n            <span *ngIf=\"day !== null\">{{ day.dayOfMonth }}</span>\n        </td>\n    </tr>\n</table>", styles: ["table{border-collapse:collapse;border:1px solid rgba(0,0,0,.125);background:#fff}table td,table th{width:40px;height:40px;text-align:center}table td span,table th span{cursor:pointer;white-space:nowrap}table td.selected{background-color:#0d6efd;color:#fff}table th{background-color:#f8f9fa}table tr{border-top:none}table tr:first-child>td{border-bottom:1px solid rgba(0,0,0,.125)}table tr:nth-of-type(2)>th:not(:nth-of-type(1)){border-bottom:1px solid rgba(0,0,0,.125)}table tr:not(:nth-of-type(2))>th:nth-of-type(1){border-right:1px solid rgba(0,0,0,.125)}\n"] }]
        }], ctorParameters: function () { return [{ type: BsCalendarMonthService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { currentMonthChange: [{
                type: Output
            }], currentMonth: [{
                type: Input
            }], selectedDateChange: [{
                type: Output
            }], selectedDate: [{
                type: Input
            }] } });

class BsMonthNamePipeModule {
}
BsMonthNamePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMonthNamePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsMonthNamePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMonthNamePipeModule, declarations: [MonthNamePipe], imports: [CommonModule], exports: [MonthNamePipe] });
BsMonthNamePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMonthNamePipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMonthNamePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MonthNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        MonthNamePipe
                    ]
                }]
        }] });

class BsUcFirstPipeModule {
}
BsUcFirstPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsUcFirstPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsUcFirstPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsUcFirstPipeModule, declarations: [UcFirstPipe], imports: [CommonModule], exports: [UcFirstPipe] });
BsUcFirstPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsUcFirstPipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsUcFirstPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UcFirstPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        UcFirstPipe
                    ]
                }]
        }] });

class WeekdayNamePipe {
    transform(date, ...args) {
        return date.toLocaleString("default", { weekday: 'short' });
    }
}
WeekdayNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: WeekdayNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
WeekdayNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: WeekdayNamePipe, name: "weekdayName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: WeekdayNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'weekdayName'
                }]
        }] });

class BsWeekdayNameModule {
}
BsWeekdayNameModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsWeekdayNameModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsWeekdayNameModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsWeekdayNameModule, declarations: [WeekdayNamePipe], imports: [CommonModule], exports: [WeekdayNamePipe] });
BsWeekdayNameModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsWeekdayNameModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsWeekdayNameModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        WeekdayNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        WeekdayNamePipe
                    ]
                }]
        }] });

class BsCalendarModule {
}
BsCalendarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCalendarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarModule, declarations: [BsCalendarComponent], imports: [CommonModule,
        BsUcFirstPipeModule,
        BsMonthNamePipeModule,
        BsWeekdayNameModule], exports: [BsCalendarComponent] });
BsCalendarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarModule, imports: [[
            CommonModule,
            BsUcFirstPipeModule,
            BsMonthNamePipeModule,
            BsWeekdayNameModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCalendarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCalendarComponent
                    ],
                    imports: [
                        CommonModule,
                        BsUcFirstPipeModule,
                        BsMonthNamePipeModule,
                        BsWeekdayNameModule
                    ],
                    exports: [
                        BsCalendarComponent
                    ]
                }]
        }] });

class BsCardComponent {
    constructor() {
    }
    ngOnInit() {
    }
    ngAfterViewInit() {
    }
}
BsCardComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCardComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsCardComponent, selector: "bs-card", ngImport: i0, template: "<div class=\"card\" style=\"width: 18rem;\">\n    <ng-content select=\"bs-card-header\"></ng-content>\n    <div class=\"card-block\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card-block{margin:-1px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-card', template: "<div class=\"card\" style=\"width: 18rem;\">\n    <ng-content select=\"bs-card-header\"></ng-content>\n    <div class=\"card-block\">\n        <ng-content></ng-content>\n    </div>\n</div>", styles: [".card-block{margin:-1px}\n"] }]
        }], ctorParameters: function () { return []; } });

class BsCardHeaderComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
BsCardHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCardHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsCardHeaderComponent, selector: "bs-card-header", ngImport: i0, template: "<div class=\"card-header\">\n    <ng-content></ng-content>\n</div>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-card-header', template: "<div class=\"card-header\">\n    <ng-content></ng-content>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class BsCardModule {
}
BsCardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardModule, declarations: [BsCardComponent,
        BsCardHeaderComponent], imports: [CommonModule], exports: [BsCardComponent,
        BsCardHeaderComponent] });
BsCardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsCardComponent,
                        BsCardHeaderComponent
                    ],
                    exports: [
                        BsCardComponent,
                        BsCardHeaderComponent
                    ]
                }]
        }] });

class BsCarouselImageDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
        this.itemTemplate = this.templateRef;
    }
}
BsCarouselImageDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselImageDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsCarouselImageDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsCarouselImageDirective, selector: "*[bsCarouselImage]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselImageDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '*[bsCarouselImage]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class BsCarouselComponent {
    constructor() {
        this.animationsDisabled = false;
        //#region Animation
        this._animation = 'slide';
        //#endregion
        this.destroyed$ = new Subject();
        this.currentImageCounter$ = new BehaviorSubject(-1);
        this.currentImageIndex$ = this.currentImageCounter$
            .pipe(map$1((counter) => {
            const l = this.images.length;
            return ((counter % l) + l) % l;
        }))
            .pipe(takeUntil$1(this.destroyed$));
        this.currentImage$ = this.currentImageIndex$
            .pipe(map$1((index) => this.images.get(index)?.itemTemplate ?? null))
            .pipe(takeUntil$1(this.destroyed$));
    }
    ngOnInit() { }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    ngAfterContentInit() {
        if (this.images.length > 0) {
            this.currentImageCounter$.next(0);
        }
        else {
            this.currentImageCounter$.next(-1);
        }
    }
    set animation(value) {
        this.animationsDisabled = true;
        this._animation = value;
        setTimeout(() => {
            this.animationsDisabled = false;
        }, 20);
    }
    get animation() {
        return this._animation;
    }
    previousImage() {
        this.currentImageCounter$
            .pipe(take$1(1))
            .subscribe((currentImageCounter) => {
            this.currentImageCounter$.next(currentImageCounter - 1);
        });
    }
    nextImage() {
        this.currentImageCounter$
            .pipe(take$1(1))
            .subscribe((currentImageCounter) => {
            this.currentImageCounter$.next(currentImageCounter + 1);
        });
    }
    setCurrentImage(index) {
        const currentValue = this.currentImageCounter$.value;
        const l = this.images.length;
        const counterMod = ((currentValue % l) + l) % l;
        const newValue = currentValue - counterMod + index;
        this.currentImageCounter$.next(newValue);
    }
}
BsCarouselComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsCarouselComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsCarouselComponent, selector: "bs-carousel", inputs: { animation: "animation" }, host: { properties: { "@.disabled": "this.animationsDisabled" } }, queries: [{ propertyName: "images", predicate: BsCarouselImageDirective }], ngImport: i0, template: "<div class=\"carousel slide\">\n    <div class=\"carousel-indicators\">\n        <button *ngFor=\"let image of images; let i = index\" type=\"button\" (click)=\"setCurrentImage(i)\"\n            [class.active]=\"(currentImageIndex$ | async) === i\" data-bs-target\n            [attr.aria-current]=\"(currentImageIndex$ | async) === i ? true : null\"\n            [attr.aria-label]=\"'Slide ' + i\"></button>\n    </div>\n\n    <div class=\"carousel-inner\" [@carouselSlide]=\"currentImageCounter$ | async\" *ngIf=\"animation === 'slide'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n    <div class=\"carousel-inner\" *ngIf=\"animation === 'fade'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" @fadeInOut *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n\n    <button class=\"carousel-control-prev\" type=\"button\" (click)=\"previousImage()\">\n        <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Previous</span>\n    </button>\n    <button class=\"carousel-control-next\" type=\"button\" (click)=\"nextImage()\">\n        <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Next</span>\n    </button>\n</div>", styles: [".carousel{min-height:100px}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "async": i1.AsyncPipe }, animations: [FadeInOutAnimation, CarouselSlideAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-carousel', animations: [FadeInOutAnimation, CarouselSlideAnimation], template: "<div class=\"carousel slide\">\n    <div class=\"carousel-indicators\">\n        <button *ngFor=\"let image of images; let i = index\" type=\"button\" (click)=\"setCurrentImage(i)\"\n            [class.active]=\"(currentImageIndex$ | async) === i\" data-bs-target\n            [attr.aria-current]=\"(currentImageIndex$ | async) === i ? true : null\"\n            [attr.aria-label]=\"'Slide ' + i\"></button>\n    </div>\n\n    <div class=\"carousel-inner\" [@carouselSlide]=\"currentImageCounter$ | async\" *ngIf=\"animation === 'slide'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n    <div class=\"carousel-inner\" *ngIf=\"animation === 'fade'\">\n        <ng-container *ngFor=\"let image of images; let i = index\">\n            <div class=\"carousel-item\" [class.active]=\"true\" @fadeInOut *ngIf=\"(currentImageIndex$ | async) === i\">\n                <ng-container [ngTemplateOutlet]=\"image.itemTemplate\"></ng-container>    \n            </div>\n        </ng-container>\n    </div>\n\n    <button class=\"carousel-control-prev\" type=\"button\" (click)=\"previousImage()\">\n        <span class=\"carousel-control-prev-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Previous</span>\n    </button>\n    <button class=\"carousel-control-next\" type=\"button\" (click)=\"nextImage()\">\n        <span class=\"carousel-control-next-icon\" aria-hidden=\"true\"></span>\n        <span class=\"visually-hidden\">Next</span>\n    </button>\n</div>", styles: [".carousel{min-height:100px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { animationsDisabled: [{
                type: HostBinding,
                args: ['@.disabled']
            }], animation: [{
                type: Input
            }], images: [{
                type: ContentChildren,
                args: [BsCarouselImageDirective]
            }] } });

class BsCarouselModule {
}
BsCarouselModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsCarouselModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselModule, declarations: [BsCarouselComponent,
        BsCarouselImageDirective], imports: [CommonModule], exports: [BsCarouselComponent,
        BsCarouselImageDirective] });
BsCarouselModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCarouselComponent,
                        BsCarouselImageDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsCarouselComponent,
                        BsCarouselImageDirective
                    ]
                }]
        }] });

class BsContextMenuDirective {
    constructor(overlay, templateRef, viewContainerRef, element) {
        this.overlay = overlay;
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.element = element;
        this.overlayRef = null;
        this.templatePortal = null;
        this.element.nativeElement.oncontextmenu = (ev) => {
            ev.preventDefault();
            this.checkAndCloseExisting(ev);
            this.overlayRef = this.overlay.create({
                scrollStrategy: this.overlay.scrollStrategies.noop(),
                positionStrategy: this.overlay.position()
                    .global()
                    .left(ev.x + 'px')
                    .bottom((window.innerHeight - ev.y) + 'px')
                    .top(ev.y + 'px')
            });
            this.templatePortal = new TemplatePortal(this.templateRef, this.viewContainerRef);
            this.overlayRef.attach(this.templatePortal);
        };
    }
    clickAnywhere(ev) {
        this.checkAndCloseExisting(ev);
    }
    checkAndCloseExisting(ev) {
        if (this.overlayRef) {
            if (!this.overlayRef.overlayElement.contains(ev.target)) {
                this.overlayRef.detach();
                this.overlayRef.dispose();
                this.overlayRef = null;
            }
        }
    }
}
BsContextMenuDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuDirective, deps: [{ token: i1$1.Overlay }, { token: i0.TemplateRef }, { token: i0.ViewContainerRef }, { token: i0.ElementRef, host: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
BsContextMenuDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsContextMenuDirective, selector: "[bsContextMenu]", host: { listeners: { "document:click": "clickAnywhere($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsContextMenu]'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.TemplateRef }, { type: i0.ViewContainerRef }, { type: i0.ElementRef, decorators: [{
                    type: Host
                }, {
                    type: SkipSelf
                }] }]; }, propDecorators: { clickAnywhere: [{
                type: HostListener,
                args: ['document:click', ['$event']]
            }] } });

class BsContextMenuModule {
}
BsContextMenuModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsContextMenuModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuModule, declarations: [BsContextMenuDirective], imports: [CommonModule], exports: [BsContextMenuDirective] });
BsContextMenuModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsContextMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsContextMenuDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsContextMenuDirective
                    ]
                }]
        }] });

class BsDatatableColumnDirective {
    constructor(templateRef) {
        this.bsDatatableColumn = { name: '', sortable: true };
        this.templateRef = templateRef;
    }
}
BsDatatableColumnDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableColumnDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDatatableColumnDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsDatatableColumnDirective, selector: "[bsDatatableColumn]", inputs: { bsDatatableColumn: "bsDatatableColumn" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableColumnDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDatatableColumn]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { bsDatatableColumn: [{
                type: Input
            }] } });

class DatatableSettings {
    constructor(data) {
        this.sortProperty = '';
        this.sortDirection = 'ascending';
        Object.assign(this, data);
        if (data && data.perPage) {
            this.perPage = data.perPage;
        }
        else {
            // Set default value
            this.perPage = {
                values: [10, 20, 50],
                selected: 20
            };
        }
        if (data && data.page) {
            this.page = data.page;
        }
        else {
            // Set default value
            this.page = {
                values: [1],
                selected: 1
            };
        }
    }
    toPagination() {
        const res = {
            sortProperty: this.sortProperty,
            sortDirection: this.sortDirection,
            perPage: this.perPage.selected,
            page: this.page.selected
        };
        return res;
    }
}

class BsPaginationComponent {
    constructor() {
        /** All page numbers. */
        this.pageNumbers$ = new BehaviorSubject([]);
        /** Selected number. */
        this.selectedPageNumber$ = new BehaviorSubject(1);
        /** Number of boxes. */
        this.numberOfBoxes$ = new BehaviorSubject(0);
        /** Display previous/next arrows. */
        this.showArrows$ = new BehaviorSubject(true);
        /** Indicates if first value is selected. */
        this.isFirstPage$ = new Observable();
        /** Indicates if last value is selected. */
        this.isLastPage$ = new Observable();
        /** The number of boxes (excluding arrows) that's being shown on the pagination component. */
        this.visibleNumberOfNumberBoxes$ = new Observable();
        this._selectedPageNumber = 0;
        this.selectedPageNumberChange = new EventEmitter();
        this._numberOfBoxes = 0;
        this._pageNumbers = [];
        this._showArrows = true;
        this.destroyed$ = new Subject();
        this.visibleNumberOfNumberBoxes$ =
            combineLatest([this.numberOfBoxes$, this.pageNumbers$, this.showArrows$])
                .pipe(takeUntil(this.destroyed$))
                .pipe(map(([numberOfBoxes, pageNumbers, showArrows]) => {
                if (numberOfBoxes <= 0) {
                    return pageNumbers.length;
                }
                else if (!showArrows) {
                    return Math.min(numberOfBoxes, pageNumbers.length);
                }
                else if (numberOfBoxes <= 2) {
                    return Math.min(1, pageNumbers.length);
                }
                else {
                    return Math.min(numberOfBoxes - 2, pageNumbers.length);
                }
            }));
        this.shownPageNumbers$ =
            combineLatest([this.pageNumbers$, this.selectedPageNumber$, this.visibleNumberOfNumberBoxes$])
                .pipe(takeUntil(this.destroyed$))
                .pipe(map(([pageNumbers, selectedPageNumber, visibleNumberOfNumberBoxes]) => {
                let startIndex = 0;
                const half = Math.round((visibleNumberOfNumberBoxes - 1) / 2);
                if (pageNumbers.indexOf(selectedPageNumber) < half) {
                    startIndex = 0;
                }
                else if (pageNumbers.indexOf(selectedPageNumber) >= (pageNumbers.length - half)) {
                    startIndex = pageNumbers.length - visibleNumberOfNumberBoxes;
                }
                else {
                    startIndex = pageNumbers.indexOf(selectedPageNumber) - half;
                }
                return [...Array(visibleNumberOfNumberBoxes).keys()]
                    .map(p => p + startIndex)
                    .map(p => ({
                    page: pageNumbers[p],
                    selected: pageNumbers[p] === selectedPageNumber
                }));
            }));
        this.isFirstPage$ =
            combineLatest([this.pageNumbers$, this.selectedPageNumber$])
                .pipe(takeUntil(this.destroyed$))
                .pipe(map(([pageNumbers, selectedPageNumber]) => {
                return pageNumbers.indexOf(selectedPageNumber) === 0;
            }));
        this.isLastPage$ =
            combineLatest([this.pageNumbers$, this.selectedPageNumber$])
                .pipe(takeUntil(this.destroyed$))
                .pipe(map(([pageNumbers, selectedPageNumber]) => {
                return pageNumbers.indexOf(selectedPageNumber) === (pageNumbers.length - 1);
            }));
        this.selectedPageNumber$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((selectedPageNumber) => {
            this.selectedPageNumberChange.emit(selectedPageNumber);
        });
    }
    ngOnInit() {
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
    onSelectPage(event, page) {
        this.selectedPageNumber$.next(page);
        return false;
    }
    onPrevious() {
        this.selectedPageNumber$.next(this.selectedPageNumber$.value - 1);
        return false;
    }
    onNext() {
        this.selectedPageNumber$.next(this.selectedPageNumber$.value + 1);
        return false;
    }
    set selectedPageNumber(value) {
        this._selectedPageNumber = value;
        this.selectedPageNumber$.next(value);
    }
    get selectedPageNumber() {
        return this._selectedPageNumber;
    }
    set numberOfBoxes(value) {
        this._numberOfBoxes = value;
        this.numberOfBoxes$.next(value);
    }
    get numberOfBoxes() {
        return this._numberOfBoxes;
    }
    set pageNumbers(value) {
        this._pageNumbers = value;
        this.pageNumbers$.next(value);
    }
    get pageNumbers() {
        return this._pageNumbers;
    }
    set showArrows(value) {
        this._showArrows = value;
        this.showArrows$.next(value);
    }
    get showArrows() {
        return this._showArrows;
    }
}
BsPaginationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsPaginationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsPaginationComponent, selector: "bs-pagination", inputs: { selectedPageNumber: "selectedPageNumber", numberOfBoxes: "numberOfBoxes", pageNumbers: "pageNumbers", showArrows: "showArrows" }, outputs: { selectedPageNumberChange: "selectedPageNumberChange" }, ngImport: i0, template: "<ul class=\"pagination\">\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isFirstPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onPrevious()\" aria-label=\"Previous\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"visually-hidden\">Previous</span>\n        </a>\n    </li>\n    <li *ngFor=\"let pageNumber of (shownPageNumbers$ | async)\" class=\"page-item\"\n        [ngClass]=\"{ 'active': pageNumber.selected }\">\n        <a class=\"page-link\" href=\"\" (click)=\"onSelectPage($event, pageNumber.page)\" *ngIf=\"pageNumber.page != '...'\">\n            {{ pageNumber.page }}\n            <span class=\"visually-hidden\" *ngIf=\"pageNumber.selected\">(current)</span>\n        </a>\n    </li>\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isLastPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onNext()\" aria-label=\"Next\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"visually-hidden\">Next</span>\n        </a>\n    </li>\n</ul>", styles: [":host{display:inline-block}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-pagination', template: "<ul class=\"pagination\">\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isFirstPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onPrevious()\" aria-label=\"Previous\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"visually-hidden\">Previous</span>\n        </a>\n    </li>\n    <li *ngFor=\"let pageNumber of (shownPageNumbers$ | async)\" class=\"page-item\"\n        [ngClass]=\"{ 'active': pageNumber.selected }\">\n        <a class=\"page-link\" href=\"\" (click)=\"onSelectPage($event, pageNumber.page)\" *ngIf=\"pageNumber.page != '...'\">\n            {{ pageNumber.page }}\n            <span class=\"visually-hidden\" *ngIf=\"pageNumber.selected\">(current)</span>\n        </a>\n    </li>\n    <li class=\"page-item\" *ngIf=\"showArrows$ | async\" [class.disabled]=\"isLastPage$ | async\">\n        <a class=\"page-link\" href=\"\" (click)=\"onNext()\" aria-label=\"Next\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"visually-hidden\">Next</span>\n        </a>\n    </li>\n</ul>", styles: [":host{display:inline-block}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { selectedPageNumberChange: [{
                type: Output
            }], selectedPageNumber: [{
                type: Input
            }], numberOfBoxes: [{
                type: Input
            }], pageNumbers: [{
                type: Input
            }], showArrows: [{
                type: Input
            }] } });

class BsDatatableComponent {
    constructor() {
        this.columns = [];
        this.onReloadData = new EventEmitter();
        this.settings = new DatatableSettings();
        this.settings.sortProperty = '';
        this.settings.sortDirection = 'ascending';
        this.settings.perPage = { values: [10, 20, 50], selected: 20 };
        this.settings.page = { values: [1], selected: 1 };
    }
    columnHeaderClicked(column) {
        if (column.bsDatatableColumn.sortable) {
            if (this.settings.sortProperty !== column.bsDatatableColumn.name) {
                this.settings.sortProperty = column.bsDatatableColumn.name;
                this.settings.sortDirection = 'ascending';
            }
            else if (this.settings.sortDirection === 'descending') {
                this.settings.sortDirection = 'ascending';
            }
            else {
                this.settings.sortDirection = 'descending';
            }
            this.onReloadData.emit();
        }
    }
    ngOnInit() {
    }
}
BsDatatableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDatatableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsDatatableComponent, selector: "bs-datatable", inputs: { settings: "settings", data: "data" }, outputs: { onReloadData: "onReloadData" }, queries: [{ propertyName: "columns", predicate: BsDatatableColumnDirective }], ngImport: i0, template: "<div class=\"table-responsive overflow-y-hidden mb-3\">\n    <table class=\"table table-striped table-hover w-100 mb-0\" cellspacing=\"0\" role=\"grid\">\n        <thead>\n            <tr>\n                <th *ngFor=\"let column of columns\" class=\"text-nowrap\"\n                    [class.sort]=\"column.bsDatatableColumn.sortable\"\n                    [class.sort-asc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'ascending')\"\n                    [class.sort-desc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'descending')\"\n                    (click)=\"columnHeaderClicked(column)\">\n                    <ng-container *ngTemplateOutlet=\"column.templateRef\"></ng-container>\n                </th>\n            </tr>\n        </thead>\n        <tbody>\n            <ng-container *ngIf=\"!!data && !!rowTemplate\">\n                <ng-container *ngFor=\"let item of data.data\">\n                    <ng-container *ngTemplateOutlet=\"rowTemplate; context: { $implicit: item }\"></ng-container>\n                </ng-container>\n            </ng-container>\n        </tbody>\n    </table>\n</div>\n<div class=\"container-fluid\">\n    <div class=\"row\">\n        <div class=\"col-md-12\">\n            <bs-pagination class=\"float-start\" [pageNumbers]=\"settings.perPage.values\"\n                [(selectedPageNumber)]=\"settings.perPage.selected\" (selectedPageNumberChange)=\"onReloadData.emit()\"\n                [showArrows]=\"false\"></bs-pagination>\n            <bs-pagination class=\"float-end\" [pageNumbers]=\"settings.page.values\"\n                [(selectedPageNumber)]=\"settings.page.selected\" (selectedPageNumberChange)=\"onReloadData.emit()\"\n                [showArrows]=\"true\"></bs-pagination>\n        </div>\n    </div>\n</div>", styles: ["@charset \"UTF-8\";.overflow-y-hidden{overflow-y:hidden}.table thead th.sort{position:relative;cursor:pointer}.table thead th.sort:before,.table thead th.sort:after{position:absolute;display:block;opacity:.3;bottom:.5em}.table thead th.sort:before{content:\"\\2191\";right:1em}.table thead th.sort:after{content:\"\\2193\";right:.5em}.table thead th.sort.sort-asc:after{opacity:1}.table thead th.sort.sort-desc:before{opacity:1}\n"], components: [{ type: BsPaginationComponent, selector: "bs-pagination", inputs: ["selectedPageNumber", "numberOfBoxes", "pageNumbers", "showArrows"], outputs: ["selectedPageNumberChange"] }], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-datatable', template: "<div class=\"table-responsive overflow-y-hidden mb-3\">\n    <table class=\"table table-striped table-hover w-100 mb-0\" cellspacing=\"0\" role=\"grid\">\n        <thead>\n            <tr>\n                <th *ngFor=\"let column of columns\" class=\"text-nowrap\"\n                    [class.sort]=\"column.bsDatatableColumn.sortable\"\n                    [class.sort-asc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'ascending')\"\n                    [class.sort-desc]=\"column.bsDatatableColumn.sortable && (settings.sortProperty === column.bsDatatableColumn.name) && (settings.sortDirection === 'descending')\"\n                    (click)=\"columnHeaderClicked(column)\">\n                    <ng-container *ngTemplateOutlet=\"column.templateRef\"></ng-container>\n                </th>\n            </tr>\n        </thead>\n        <tbody>\n            <ng-container *ngIf=\"!!data && !!rowTemplate\">\n                <ng-container *ngFor=\"let item of data.data\">\n                    <ng-container *ngTemplateOutlet=\"rowTemplate; context: { $implicit: item }\"></ng-container>\n                </ng-container>\n            </ng-container>\n        </tbody>\n    </table>\n</div>\n<div class=\"container-fluid\">\n    <div class=\"row\">\n        <div class=\"col-md-12\">\n            <bs-pagination class=\"float-start\" [pageNumbers]=\"settings.perPage.values\"\n                [(selectedPageNumber)]=\"settings.perPage.selected\" (selectedPageNumberChange)=\"onReloadData.emit()\"\n                [showArrows]=\"false\"></bs-pagination>\n            <bs-pagination class=\"float-end\" [pageNumbers]=\"settings.page.values\"\n                [(selectedPageNumber)]=\"settings.page.selected\" (selectedPageNumberChange)=\"onReloadData.emit()\"\n                [showArrows]=\"true\"></bs-pagination>\n        </div>\n    </div>\n</div>", styles: ["@charset \"UTF-8\";.overflow-y-hidden{overflow-y:hidden}.table thead th.sort{position:relative;cursor:pointer}.table thead th.sort:before,.table thead th.sort:after{position:absolute;display:block;opacity:.3;bottom:.5em}.table thead th.sort:before{content:\"\\2191\";right:1em}.table thead th.sort:after{content:\"\\2193\";right:.5em}.table thead th.sort.sort-asc:after{opacity:1}.table thead th.sort.sort-desc:before{opacity:1}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { columns: [{
                type: ContentChildren,
                args: [BsDatatableColumnDirective]
            }], settings: [{
                type: Input
            }], data: [{
                type: Input
            }], onReloadData: [{
                type: Output
            }] } });

class BsRowTemplateDirective {
    constructor(datatableComponent, templateRef) {
        this.datatableComponent = datatableComponent;
        this.datatableComponent.rowTemplate = templateRef;
    }
}
BsRowTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsRowTemplateDirective, deps: [{ token: BsDatatableComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsRowTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsRowTemplateDirective, selector: "[rowTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsRowTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rowTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: BsDatatableComponent }, { type: i0.TemplateRef }]; } });

class BsPaginationModule {
}
BsPaginationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsPaginationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationModule, declarations: [BsPaginationComponent], imports: [CommonModule], exports: [BsPaginationComponent] });
BsPaginationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsPaginationModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsPaginationComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsPaginationComponent
                    ]
                }]
        }] });

class BsDatatableModule {
}
BsDatatableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDatatableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableModule, declarations: [BsDatatableComponent,
        BsRowTemplateDirective,
        BsDatatableColumnDirective], imports: [CommonModule,
        BsPaginationModule], exports: [BsDatatableComponent,
        BsRowTemplateDirective,
        BsDatatableColumnDirective] });
BsDatatableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableModule, imports: [[
            CommonModule,
            BsPaginationModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatatableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDatatableComponent,
                        BsRowTemplateDirective,
                        BsDatatableColumnDirective
                    ],
                    imports: [
                        CommonModule,
                        BsPaginationModule
                    ],
                    exports: [
                        BsDatatableComponent,
                        BsRowTemplateDirective,
                        BsDatatableColumnDirective
                    ]
                }]
        }] });

class BsDropdownMenuDirective extends ClickOutsideDirective {
    constructor(dropdown, document, viewContainerRef, templateRef, overlay, elementRef, zone, platformId) {
        super(elementRef, zone, platformId);
        this.dropdown = dropdown;
        this.viewContainerRef = viewContainerRef;
        this.templateRef = templateRef;
        this.overlay = overlay;
        this.wait = false;
        this.destroyed$ = new Subject();
        this.overlayRef = null;
        this.templatePortal = null;
        this.document = document;
        this.dropdown.isOpen$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((isOpen) => {
            if (isOpen) {
                this.wait = true;
                setTimeout(() => this.wait = false, 100);
                this.overlayRef = this.overlay.create({
                    hasBackdrop: this.dropdown.hasBackdrop,
                    scrollStrategy: this.overlay.scrollStrategies.reposition(),
                    positionStrategy: this.overlay.position()
                        .flexibleConnectedTo(!this.dropdown.toggle ? dropdown.elementRef : this.dropdown.toggle.toggleButton)
                        .withPositions([
                        { originX: "start", originY: "bottom", overlayX: "start", overlayY: "top", offsetY: 0 },
                        { originX: "start", originY: "top", overlayX: "start", overlayY: "bottom", offsetY: 0 },
                    ]),
                });
                if (this.dropdown.hasBackdrop && this.dropdown.closeOnClickOutside) {
                    this.overlayRef.backdropClick().subscribe(() => {
                        this.dropdown.isOpen = false;
                    });
                }
                this.templatePortal = new TemplatePortal(this.templateRef, this.viewContainerRef);
                this.overlayRef.attach(this.templatePortal);
            }
            else {
                if (this.overlayRef) {
                    this.overlayRef.detach();
                    this.overlayRef.dispose();
                    this.overlayRef = null;
                }
            }
        });
    }
    clickedOutside(ev) {
        if (!this.wait) {
            if (!this.overlayRef?.overlayElement.contains(ev.target)) {
                this.dropdown.isOpen$.pipe(take(1)).subscribe((isOpen) => {
                    if (isOpen && !this.dropdown.hasBackdrop && this.dropdown.closeOnClickOutside) {
                        this.dropdown.isOpen = false;
                    }
                });
            }
        }
    }
}
BsDropdownMenuDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownMenuDirective, deps: [{ token: forwardRef(() => BsDropdownDirective) }, { token: DOCUMENT }, { token: i0.ViewContainerRef }, { token: i0.TemplateRef }, { token: i1$1.Overlay }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownMenuDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]", host: { listeners: { "clickOutside": "clickedOutside($event)" }, properties: { "class.show": "dropdown.isOpen" } }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownMenuDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdownMenu]',
                    host: {
                        '[class.show]': 'dropdown.isOpen',
                    },
                }]
        }], ctorParameters: function () { return [{ type: BsDropdownDirective, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => BsDropdownDirective)]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }, { type: i0.ViewContainerRef }, { type: i0.TemplateRef }, { type: i1$1.Overlay }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: Object, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }]; }, propDecorators: { clickedOutside: [{
                type: HostListener,
                args: ['clickOutside', ['$event']]
            }] } });

class BsDropdownToggleDirective {
    constructor(dropdown, toggleButton) {
        this.dropdown = dropdown;
        this.toggleButton = toggleButton;
    }
    onClick() {
        this.dropdown.isOpen$.pipe(take(1)).subscribe((isOpen) => {
            this.dropdown.isOpen$.next(!isOpen);
        });
    }
}
BsDropdownToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownToggleDirective, deps: [{ token: BsDropdownDirective }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]", host: { listeners: { "click": "onClick()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdownToggle]'
                }]
        }], ctorParameters: function () { return [{ type: BsDropdownDirective }, { type: i0.ElementRef }]; }, propDecorators: { onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsDropdownDirective {
    constructor(elementRef) {
        this.isOpen$ = new BehaviorSubject(false);
        this.toggle = null;
        this.hasBackdrop = false;
        this.sameWidth = false;
        this.closeOnClickOutside = false;
        this.isOpenChange = new EventEmitter();
        this.elementRef = elementRef;
    }
    //#region IsOpen
    get isOpen() {
        return this.isOpen$.value;
    }
    set isOpen(value) {
        if (this.isOpen$.value !== value) {
            this.isOpen$.next(value);
            this.isOpenChange.emit(value);
        }
    }
}
BsDropdownDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsDropdownDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsDropdownDirective, selector: "[bsDropdown]", inputs: { hasBackdrop: "hasBackdrop", sameWidth: "sameWidth", closeOnClickOutside: "closeOnClickOutside", isOpen: "isOpen" }, outputs: { isOpenChange: "isOpenChange" }, queries: [{ propertyName: "menu", first: true, predicate: BsDropdownMenuDirective, descendants: true }, { propertyName: "toggle", first: true, predicate: BsDropdownToggleDirective, descendants: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsDropdown]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { menu: [{
                type: ContentChild,
                args: [BsDropdownMenuDirective, { static: false }]
            }], toggle: [{
                type: ContentChild,
                args: [BsDropdownToggleDirective, { static: false }]
            }], hasBackdrop: [{
                type: Input
            }], sameWidth: [{
                type: Input
            }], closeOnClickOutside: [{
                type: Input
            }], isOpenChange: [{
                type: Output
            }], isOpen: [{
                type: Input
            }] } });

class BsDatepickerComponent {
    constructor() {
        this.selectedDate = new Date();
        this.currentMonth = new Date();
    }
    ngOnInit() {
    }
}
BsDatepickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDatepickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsDatepickerComponent, selector: "bs-datepicker", ngImport: i0, template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedDate | date }}</button>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\"></bs-calendar>\n    </div>\n</div>", styles: [""], components: [{ type: BsCalendarComponent, selector: "bs-calendar", inputs: ["currentMonth", "selectedDate"], outputs: ["currentMonthChange", "selectedDateChange"] }], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "isOpen"], outputs: ["isOpenChange"] }, { type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }], pipes: { "date": i1.DatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-datepicker', template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedDate | date }}</button>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\"></bs-calendar>\n    </div>\n</div>", styles: [""] }]
        }], ctorParameters: function () { return []; } });

class BsDropdownModule {
}
BsDropdownModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDropdownModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownModule, declarations: [BsDropdownDirective,
        BsDropdownToggleDirective,
        BsDropdownMenuDirective], imports: [CommonModule,
        OverlayModule,
        ClickOutsideModule], exports: [BsDropdownDirective,
        BsDropdownToggleDirective,
        BsDropdownMenuDirective] });
BsDropdownModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownModule, imports: [[
            CommonModule,
            OverlayModule,
            ClickOutsideModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDropdownModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDropdownDirective,
                        BsDropdownToggleDirective,
                        BsDropdownMenuDirective
                    ],
                    imports: [
                        CommonModule,
                        OverlayModule,
                        ClickOutsideModule
                    ],
                    exports: [
                        BsDropdownDirective,
                        BsDropdownToggleDirective,
                        BsDropdownMenuDirective
                    ]
                }]
        }] });

class BsDatepickerModule {
}
BsDatepickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDatepickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerModule, declarations: [BsDatepickerComponent], imports: [CommonModule,
        BsCalendarModule,
        BsDropdownModule], exports: [BsDatepickerComponent] });
BsDatepickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerModule, imports: [[
            CommonModule,
            BsCalendarModule,
            BsDropdownModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsDatepickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDatepickerComponent
                    ],
                    imports: [
                        CommonModule,
                        BsCalendarModule,
                        BsDropdownModule
                    ],
                    exports: [
                        BsDatepickerComponent
                    ]
                }]
        }] });

class BsListGroupItemComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
BsListGroupItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsListGroupItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsListGroupItemComponent, selector: "bs-list-group-item", ngImport: i0, template: "<li class=\"list-group-item\">\n    <ng-content></ng-content>\n</li>", styles: [".list-group-item{margin-bottom:-1px}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-list-group-item', template: "<li class=\"list-group-item\">\n    <ng-content></ng-content>\n</li>", styles: [".list-group-item{margin-bottom:-1px}\n"] }]
        }], ctorParameters: function () { return []; } });

class BsListGroupComponent {
    constructor() {
    }
    ngOnInit() {
    }
}
BsListGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsListGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsListGroupComponent, selector: "bs-list-group", queries: [{ propertyName: "items", predicate: BsListGroupItemComponent }], ngImport: i0, template: "<ul class=\"list-group mt-0\">\n    <ng-content></ng-content>\n</ul>", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-list-group', template: "<ul class=\"list-group mt-0\">\n    <ng-content></ng-content>\n</ul>", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { items: [{
                type: ContentChildren,
                args: [BsListGroupItemComponent]
            }] } });

class BsListGroupModule {
}
BsListGroupModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsListGroupModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupModule, declarations: [BsListGroupComponent,
        BsListGroupItemComponent], imports: [CommonModule], exports: [BsListGroupComponent,
        BsListGroupItemComponent] });
BsListGroupModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsListGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [
                        BsListGroupComponent,
                        BsListGroupItemComponent
                    ],
                    exports: [
                        BsListGroupComponent,
                        BsListGroupItemComponent
                    ]
                }]
        }] });

class BsMultiselectComponent {
    constructor() {
        this.items = [];
        this.selectedItems = [];
    }
    itemChange(item, event) {
        if (!!event.target.checked) {
            this.selectedItems.push(item);
        }
        else {
            this.selectedItems.splice(this.selectedItems.findIndex((i) => i === item), 1);
        }
    }
    ngOnInit() {
    }
}
BsMultiselectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsMultiselectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsMultiselectComponent, selector: "bs-multiselect", inputs: { items: "items", selectedItems: "selectedItems" }, queries: [{ propertyName: "template", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedItems.length }} selected</button>\n    <div *bsDropdownMenu class=\"bg-white mw-250px p-3 border rounded shadow\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n        <hr class=\"my-2\">\n        <label *ngFor=\"let item of items\" class=\"form-check\">\n            <input type=\"checkbox\" [checked]=\"selectedItems.indexOf(item) > -1\" (change)=\"itemChange(item, $event)\" class=\"form-check-input\">\n            <span class=\"form-check-label\">{{ item }}</span>\n        </label>\n    </div>\n</div>", styles: [".mw-250px{min-width:250px}\n"], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "isOpen"], outputs: ["isOpenChange"] }, { type: BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-multiselect', template: "<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle class=\"btn btn-primary\">{{ selectedItems.length }} selected</button>\n    <div *bsDropdownMenu class=\"bg-white mw-250px p-3 border rounded shadow\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n        <hr class=\"my-2\">\n        <label *ngFor=\"let item of items\" class=\"form-check\">\n            <input type=\"checkbox\" [checked]=\"selectedItems.indexOf(item) > -1\" (change)=\"itemChange(item, $event)\" class=\"form-check-input\">\n            <span class=\"form-check-label\">{{ item }}</span>\n        </label>\n    </div>\n</div>", styles: [".mw-250px{min-width:250px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { template: [{
                type: ContentChild,
                args: [TemplateRef]
            }], items: [{
                type: Input
            }], selectedItems: [{
                type: Input
            }] } });

class BsMultiselectModule {
}
BsMultiselectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsMultiselectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectModule, declarations: [BsMultiselectComponent], imports: [CommonModule,
        BsDropdownModule,
        FocusOnLoadModule], exports: [BsMultiselectComponent] });
BsMultiselectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectModule, imports: [[
            CommonModule,
            BsDropdownModule,
            FocusOnLoadModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsMultiselectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsMultiselectComponent
                    ],
                    imports: [
                        CommonModule,
                        BsDropdownModule,
                        FocusOnLoadModule,
                    ],
                    exports: [
                        BsMultiselectComponent
                    ]
                }]
        }] });

class BsNavbarComponent {
    constructor() {
        this.isExpanded = false;
    }
    toggleExpanded() {
        this.isExpanded = !this.isExpanded;
    }
}
BsNavbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsNavbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsNavbarComponent, selector: "bs-navbar", viewQueries: [{ propertyName: "nav", first: true, predicate: ["nav"], descendants: true }], ngImport: i0, template: "<nav #nav class=\"navbar navbar-expand-md position-fixed navbar-dark bg-dark\">\n    <div class=\"container-fluid\">\n        <div class=\"d-flex w-100 w-md-auto\">\n            <a class=\"navbar-brand mx-auto mx-md-unset\" href=\"#\">Navbar 2</a>\n            <button (click)=\"toggleExpanded()\" class=\"navbar-toggler align-self-end\" type=\"button\" data-toggle=\"collapse\">\n                <span class=\"navbar-toggler-icon\"></span>\n            </button>\n        </div>\n        <ng-content></ng-content>\n    </div>\n</nav>", styles: [":host ::ng-deep+*{padding-top:56px}nav{left:0;top:0;right:0;z-index:10}@media (min-width: 768px){.mx-md-unset{margin-left:0!important;margin-right:0!important}.w-md-auto{width:auto!important}}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar', template: "<nav #nav class=\"navbar navbar-expand-md position-fixed navbar-dark bg-dark\">\n    <div class=\"container-fluid\">\n        <div class=\"d-flex w-100 w-md-auto\">\n            <a class=\"navbar-brand mx-auto mx-md-unset\" href=\"#\">Navbar 2</a>\n            <button (click)=\"toggleExpanded()\" class=\"navbar-toggler align-self-end\" type=\"button\" data-toggle=\"collapse\">\n                <span class=\"navbar-toggler-icon\"></span>\n            </button>\n        </div>\n        <ng-content></ng-content>\n    </div>\n</nav>", styles: [":host ::ng-deep+*{padding-top:56px}nav{left:0;top:0;right:0;z-index:10}@media (min-width: 768px){.mx-md-unset{margin-left:0!important;margin-right:0!important}.w-md-auto{width:auto!important}}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { nav: [{
                type: ViewChild,
                args: ['nav']
            }] } });

class BsNavbarNavComponent {
    constructor(bsNavbar) {
        //#region collapse
        this._collapse = true;
        this.bsNavbar = bsNavbar;
    }
    ngOnInit() {
    }
    set collapse(value) {
        this._collapse = value;
    }
    get collapse() {
        return this._collapse;
    }
}
BsNavbarNavComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarNavComponent, deps: [{ token: BsNavbarComponent }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarNavComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsNavbarNavComponent, selector: "bs-navbar-nav", inputs: { collapse: "collapse" }, ngImport: i0, template: "<div class=\"navbar-collapse collapse w-100 show\" *ngIf=\"bsNavbar.isExpanded\" [@slideUpDown]>\n    <ul class=\"navbar-nav mr-auto\">\n        <ng-content></ng-content>\n    </ul>\n</div>", styles: [":host{margin-right:auto}@media screen and (max-width: 767px){:host{width:100%!important}.navbar-collapse.collapse{overflow:hidden}}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarNavComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-nav', animations: [SlideUpDownAnimation], template: "<div class=\"navbar-collapse collapse w-100 show\" *ngIf=\"bsNavbar.isExpanded\" [@slideUpDown]>\n    <ul class=\"navbar-nav mr-auto\">\n        <ng-content></ng-content>\n    </ul>\n</div>", styles: [":host{margin-right:auto}@media screen and (max-width: 767px){:host{width:100%!important}.navbar-collapse.collapse{overflow:hidden}}\n"] }]
        }], ctorParameters: function () { return [{ type: BsNavbarComponent }]; }, propDecorators: { collapse: [{
                type: Input
            }] } });

class BsNavbarItemComponent {
    constructor(parentDropdown, element) {
        this.element = element;
        this.hasDropdown = false;
        this.anchorTag = null;
        this.parentDropdown = parentDropdown;
    }
    ngOnInit() {
    }
    ngAfterContentChecked() {
        if (this.hasDropdown) {
            window.element = this.element.nativeElement;
            this.anchorTag = this.element.nativeElement.querySelector('li a');
            (this.anchorTag) && this.anchorTag.classList.add('dropdown-toggle');
            if (this.anchorTag && !this.anchorTag.onclick) {
                this.anchorTag.onclick = (ev) => {
                    ev.preventDefault();
                    // Normally there should be only one dropdown in this list
                    this.dropdowns.forEach((dropdown) => {
                        if (!(dropdown.isVisible = !dropdown.isVisible)) {
                            dropdown.childDropdowns.forEach((child) => {
                                child.isVisible = false;
                            });
                        }
                    });
                    return false;
                };
            }
        }
    }
}
BsNavbarItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarItemComponent, deps: [{ token: BsNavbarDropdownComponent, optional: true }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsNavbarItemComponent, selector: "bs-navbar-item", queries: [{ propertyName: "dropdowns", predicate: i0.forwardRef(function () { return BsNavbarDropdownComponent; }) }], ngImport: i0, template: "<li [class.nav-item]=\"parentDropdown === null\" [class.dropdown]=\"(dropdowns.length > 0) && (parentDropdown === null)\" [class.dropend]=\"(dropdowns.length > 0) && (parentDropdown !== null)\">\n    <ng-content></ng-content>\n</li>", styles: ["li.dropend ::ng-deep a.dropdown-toggle{padding-right:1.5rem}li.dropend ::ng-deep a.dropdown-toggle:after{position:absolute;right:.5rem;top:.75rem}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-item', template: "<li [class.nav-item]=\"parentDropdown === null\" [class.dropdown]=\"(dropdowns.length > 0) && (parentDropdown === null)\" [class.dropend]=\"(dropdowns.length > 0) && (parentDropdown !== null)\">\n    <ng-content></ng-content>\n</li>", styles: ["li.dropend ::ng-deep a.dropdown-toggle{padding-right:1.5rem}li.dropend ::ng-deep a.dropdown-toggle:after{position:absolute;right:.5rem;top:.75rem}\n"] }]
        }], ctorParameters: function () { return [{ type: BsNavbarDropdownComponent, decorators: [{
                    type: Optional
                }] }, { type: i0.ElementRef }]; }, propDecorators: { dropdowns: [{
                type: ContentChildren,
                args: [forwardRef(() => BsNavbarDropdownComponent)]
            }] } });

class BsNavbarDropdownComponent {
    constructor(parentDropdown, navbarItem) {
        this.isVisible = false;
        this.parentDropdown = parentDropdown;
        this.navbarItem = navbarItem;
    }
    get elementsToExclude() {
        return [this.navbarItem.anchorTag].filter((a) => a).map((a) => a);
    }
    ngOnInit() {
    }
}
BsNavbarDropdownComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarDropdownComponent, deps: [{ token: BsNavbarDropdownComponent, host: true, optional: true, skipSelf: true }, { token: forwardRef(() => BsNavbarItemComponent), host: true }], target: i0.ɵɵFactoryTarget.Component });
BsNavbarDropdownComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsNavbarDropdownComponent, selector: "bs-navbar-dropdown", queries: [{ propertyName: "childDropdowns", predicate: i0.forwardRef(function () { return BsNavbarDropdownComponent; }), descendants: true }], ngImport: i0, template: "<ul class=\"dropdown-menu\" [class.show]=\"isVisible\" [class.submenu]=\"!!parentDropdown\" (clickOutside)=\"isVisible = false\" [exclude]=\"elementsToExclude\" aria-labelledby=\"navbarDropdown\">\n    <ng-content></ng-content>\n</ul>", styles: ["@media (max-width: 767px){.submenu{margin-left:.5rem;margin-right:.5rem}}@media (min-width: 768px){.submenu{position:absolute;left:100%;top:-1px}}\n"], directives: [{ type: i1$2.ClickOutsideDirective, selector: "[clickOutside]", inputs: ["clickOutsideEnabled", "attachOutsideOnClick", "delayClickOutsideInit", "emitOnBlur", "exclude", "excludeBeforeClick", "clickOutsideEvents"], outputs: ["clickOutside"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarDropdownComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-dropdown', template: "<ul class=\"dropdown-menu\" [class.show]=\"isVisible\" [class.submenu]=\"!!parentDropdown\" (clickOutside)=\"isVisible = false\" [exclude]=\"elementsToExclude\" aria-labelledby=\"navbarDropdown\">\n    <ng-content></ng-content>\n</ul>", styles: ["@media (max-width: 767px){.submenu{margin-left:.5rem;margin-right:.5rem}}@media (min-width: 768px){.submenu{position:absolute;left:100%;top:-1px}}\n"] }]
        }], ctorParameters: function () { return [{ type: BsNavbarDropdownComponent, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }, {
                    type: Optional
                }] }, { type: BsNavbarItemComponent, decorators: [{
                    type: Host
                }, {
                    type: Inject,
                    args: [forwardRef(() => BsNavbarItemComponent)]
                }] }]; }, propDecorators: { childDropdowns: [{
                type: ContentChildren,
                args: [forwardRef(() => BsNavbarDropdownComponent), { descendants: true }]
            }] } });

class DropdownToggleDirective {
    constructor(elementRef, bsNavbarItem, parentDropdown) {
        this.elementRef = elementRef;
        this.bsNavbarItem = bsNavbarItem;
    }
    ngAfterContentInit() {
        if (this.bsNavbarItem.dropdowns.length > 0) {
            this.bsNavbarItem.hasDropdown = true;
        }
    }
}
DropdownToggleDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: DropdownToggleDirective, deps: [{ token: i0.ElementRef }, { token: forwardRef(() => BsNavbarItemComponent) }, { token: forwardRef(() => BsNavbarDropdownComponent), optional: true }], target: i0.ɵɵFactoryTarget.Directive });
DropdownToggleDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: DropdownToggleDirective, selector: "bs-navbar-item", queries: [{ propertyName: "childDropdowns", predicate: BsNavbarDropdownComponent }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: DropdownToggleDirective, decorators: [{
            type: Directive,
            args: [{
                    // selector: 'bs-navbar-item > a[routerLink]',
                    selector: 'bs-navbar-item',
                    queries: {
                        childDropdowns: new ContentChildren(BsNavbarDropdownComponent)
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: BsNavbarItemComponent, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => BsNavbarItemComponent)]
                }] }, { type: BsNavbarDropdownComponent, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [forwardRef(() => BsNavbarDropdownComponent)]
                }] }]; } });

class NavLinkDirective {
    constructor(elementRef, parentDropdown) {
        this.elementRef = elementRef;
        if (parentDropdown == null) {
            this.elementRef.nativeElement.classList.add('nav-link');
        }
        else {
            this.elementRef.nativeElement.classList.add('dropdown-item');
        }
    }
}
NavLinkDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: NavLinkDirective, deps: [{ token: i0.ElementRef }, { token: forwardRef(() => BsNavbarDropdownComponent), optional: true }], target: i0.ɵɵFactoryTarget.Directive });
NavLinkDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: NavLinkDirective, selector: "bs-navbar-item > a[routerLink]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: NavLinkDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'bs-navbar-item > a[routerLink]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: BsNavbarDropdownComponent, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [forwardRef(() => BsNavbarDropdownComponent)]
                }] }]; } });

class NavbarContentDirective {
    constructor(element) {
        this.element = element;
        this.initialPadding = 0;
        this.resizeObserver = new ResizeObserver((entries) => {
            let height = entries[0].contentRect.height;
            this.element.nativeElement.style.paddingTop = (this.initialPadding + height) + 'px';
        });
    }
    ngAfterViewInit() {
        let p = parseInt(this.element.nativeElement.style.paddingTop.replace(/px$/, ''));
        this.initialPadding = isNaN(p) ? 0 : p;
        this.resizeObserver.observe(this.navbar.nav.nativeElement);
    }
    ngOnDestroy() {
        this.resizeObserver.unobserve(this.navbar.nav.nativeElement);
    }
}
NavbarContentDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: NavbarContentDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NavbarContentDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: NavbarContentDirective, selector: "[navbarContent]", inputs: { navbar: ["navbarContent", "navbar"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: NavbarContentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[navbarContent]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { navbar: [{
                type: Input,
                args: ['navbarContent']
            }] } });

class BsNavbarModule {
}
BsNavbarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsNavbarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarModule, declarations: [BsNavbarComponent,
        BsNavbarNavComponent,
        BsNavbarDropdownComponent,
        BsNavbarItemComponent,
        DropdownToggleDirective,
        NavLinkDirective,
        NavbarContentDirective], imports: [CommonModule,
        RouterModule,
        ClickOutsideModule], exports: [BsNavbarComponent,
        BsNavbarNavComponent,
        BsNavbarDropdownComponent,
        BsNavbarItemComponent,
        DropdownToggleDirective,
        NavLinkDirective,
        NavbarContentDirective] });
BsNavbarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarModule, imports: [[
            CommonModule,
            RouterModule,
            ClickOutsideModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsNavbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsNavbarComponent,
                        BsNavbarNavComponent,
                        BsNavbarDropdownComponent,
                        BsNavbarItemComponent,
                        DropdownToggleDirective,
                        NavLinkDirective,
                        NavbarContentDirective
                    ],
                    imports: [
                        CommonModule,
                        RouterModule,
                        ClickOutsideModule
                    ],
                    exports: [
                        BsNavbarComponent,
                        BsNavbarNavComponent,
                        BsNavbarDropdownComponent,
                        BsNavbarItemComponent,
                        DropdownToggleDirective,
                        NavLinkDirective,
                        NavbarContentDirective
                    ]
                }]
        }] });

class BsProgressComponent {
    constructor() {
        this.progressClass = true;
        this.height = null;
        this.isIndeterminate = false;
    }
}
BsProgressComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsProgressComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsProgressComponent, selector: "bs-progress", inputs: { height: "height", isIndeterminate: "isIndeterminate" }, host: { properties: { "class.progress": "this.progressClass", "style.height.px": "this.height" } }, ngImport: i0, template: "<ng-content *ngIf=\"!isIndeterminate\"></ng-content>\n<div *ngIf=\"isIndeterminate\" class=\"progress-bar progress-bar-infinite\" role=\"progressbar\" aria-valuenow=\"infinite\"></div>", styles: ["@keyframes progress-infinite{0%{width:10%;margin-left:0%}25%{width:70%;margin-left:15%}50%{width:10%;margin-left:90%}75%{width:70%;margin-left:15%}to{width:10%;margin-left:0%}}.progress-bar-infinite{animation:progress-infinite 1.5s infinite}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-progress', template: "<ng-content *ngIf=\"!isIndeterminate\"></ng-content>\n<div *ngIf=\"isIndeterminate\" class=\"progress-bar progress-bar-infinite\" role=\"progressbar\" aria-valuenow=\"infinite\"></div>", styles: ["@keyframes progress-infinite{0%{width:10%;margin-left:0%}25%{width:70%;margin-left:15%}50%{width:10%;margin-left:90%}75%{width:70%;margin-left:15%}to{width:10%;margin-left:0%}}.progress-bar-infinite{animation:progress-infinite 1.5s infinite}\n"] }]
        }], propDecorators: { progressClass: [{
                type: HostBinding,
                args: ['class.progress']
            }], height: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['style.height.px']
            }], isIndeterminate: [{
                type: Input
            }] } });

class BsProgressBarComponent {
    constructor() {
        this.destroyed$ = new Subject();
        this.minimum$ = new BehaviorSubject(0);
        this.maximum$ = new BehaviorSubject(100);
        this.value$ = new BehaviorSubject(50);
        this.color$ = new BehaviorSubject(Color.primary);
        this.striped = false;
        this.animated = false;
        this.progressBar = true;
        this.colorClass = 'bg-primary';
        this.widthStyle = '0';
        this.role = 'progressbar';
        this.valueNow = 50;
        this.valueMin = 0;
        this.valueMax = 100;
        this.percentage$ = combineLatest([this.minimum$, this.maximum$, this.value$])
            .pipe(map(([minimum, maximum, value]) => {
            return (value - minimum) / (maximum - minimum) * 100;
        }));
        this.width$ = this.percentage$
            .pipe(map((width) => {
            return String(width) + '%';
        }));
        this.colorClass$ = this.color$
            .pipe(map((color) => {
            const name = Color[color];
            return `bg-${name}`;
        }));
        this.colorClass$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((color) => {
            this.colorClass = color;
        });
        this.width$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((width) => {
            this.widthStyle = width;
        });
        this.value$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueNow = value;
        });
        this.minimum$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueMin = value;
        });
        this.maximum$
            .pipe(takeUntil(this.destroyed$))
            .subscribe((value) => {
            this.valueMax = value;
        });
    }
    set minimum(value) {
        this.minimum$.next(value);
    }
    set maximum(value) {
        this.maximum$.next(value);
    }
    set value(value) {
        this.value$.next(value);
    }
    set color(value) {
        this.color$.next(value);
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
BsProgressBarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsProgressBarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsProgressBarComponent, selector: "bs-progress-bar", inputs: { minimum: "minimum", maximum: "maximum", value: "value", color: "color", striped: "striped", animated: "animated" }, host: { properties: { "class.progress-bar-striped": "this.striped", "class.progress-bar-animated": "this.animated", "class.progress-bar": "this.progressBar", "class": "this.colorClass", "style.width": "this.widthStyle", "attr.role": "this.role", "attr.aria-valuenow": "this.valueNow", "attr.aria-valuemin": "this.valueMin", "attr.aria-valuemax": "this.valueMax" } }, ngImport: i0, template: "", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-progress-bar', template: "", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { minimum: [{
                type: Input
            }], maximum: [{
                type: Input
            }], value: [{
                type: Input
            }], color: [{
                type: Input
            }], striped: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.progress-bar-striped']
            }], animated: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.progress-bar-animated']
            }], progressBar: [{
                type: HostBinding,
                args: ['class.progress-bar']
            }], colorClass: [{
                type: HostBinding,
                args: ['class']
            }], widthStyle: [{
                type: HostBinding,
                args: ['style.width']
            }], role: [{
                type: HostBinding,
                args: ['attr.role']
            }], valueNow: [{
                type: HostBinding,
                args: ['attr.aria-valuenow']
            }], valueMin: [{
                type: HostBinding,
                args: ['attr.aria-valuemin']
            }], valueMax: [{
                type: HostBinding,
                args: ['attr.aria-valuemax']
            }] } });

class BsProgressBarModule {
}
BsProgressBarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsProgressBarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarModule, declarations: [BsProgressBarComponent,
        BsProgressComponent], imports: [CommonModule], exports: [BsProgressBarComponent,
        BsProgressComponent] });
BsProgressBarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsProgressBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsProgressBarComponent,
                        BsProgressComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsProgressBarComponent,
                        BsProgressComponent
                    ]
                }]
        }] });

class BsScrollOffsetService {
    constructor(routerConfig) {
        this.routerConfig = routerConfig;
    }
    getScrollOffset() {
        if (!this.routerConfig.scrollOffset) {
            return [0, 0];
        }
        else if (Array.isArray(this.routerConfig.scrollOffset)) {
            return this.routerConfig.scrollOffset;
        }
        else {
            return this.routerConfig.scrollOffset();
        }
    }
}
BsScrollOffsetService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollOffsetService, deps: [{ token: ROUTER_CONFIGURATION }], target: i0.ɵɵFactoryTarget.Injectable });
BsScrollOffsetService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollOffsetService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollOffsetService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [ROUTER_CONFIGURATION]
                }] }]; } });

class BsScrollspyDirective {
    constructor(element) {
        this.element = element;
    }
}
BsScrollspyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
BsScrollspyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsScrollspyDirective, selector: "[bsScrollspy]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsScrollspy]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });

class BsScrollspyComponent {
    constructor(scrollOffsetService, document) {
        this.scrollOffsetService = scrollOffsetService;
        this.activeDirective = null;
        this.doc = document;
    }
    ngAfterViewInit() {
        this.onWindowScroll();
    }
    onWindowScroll() {
        const offsetY = this.scrollOffsetService.getScrollOffset()[1];
        const dirs = this.directives.filter((d) => d.element.nativeElement.getBoundingClientRect().y < offsetY);
        if (this.directives.length === 0) {
            this.activeDirective = null;
        }
        else if (dirs.length === 0) {
            this.activeDirective = this.directives.get(0) ?? null;
        }
        else {
            this.activeDirective = dirs[dirs.length - 1];
        }
        if (window && (window.innerWidth >= 768)) {
            if (this.activeDirective) {
                const index = this.directives.toArray().findIndex((v, i) => v === this.activeDirective);
                const anchor = this.anchors.get(index);
                if (anchor && anchor.nativeElement.parentElement) {
                    anchor.nativeElement.scrollIntoView({ block: 'nearest', inline: 'nearest' });
                }
            }
        }
    }
    scrollToHeader(directive) {
        const header = directive.element.nativeElement;
        const offsetY = this.scrollOffsetService.getScrollOffset()[1];
        const y = header.getBoundingClientRect().top + window.scrollY - offsetY + 1;
        window.scrollTo({ top: y, behavior: 'smooth' });
    }
}
BsScrollspyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyComponent, deps: [{ token: BsScrollOffsetService }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component });
BsScrollspyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsScrollspyComponent, selector: "bs-scrollspy", host: { listeners: { "window:scroll": "onWindowScroll($event)" } }, queries: [{ propertyName: "directives", predicate: BsScrollspyDirective, descendants: true }], viewQueries: [{ propertyName: "anchors", predicate: ["anchor"], descendants: true }], ngImport: i0, template: "<div class=\"spy\">\n    <ul class=\"text-muted\">\n        <li *ngFor=\"let dir of directives; let i = index\">\n            <span [attr.data-index]=\"i\" class=\"cursor-pointer\" [ngClass]=\"'nav' + dir.element.nativeElement.tagName\" [class.fw-bold]=\"activeDirective?.element === dir.element\" (click)=\"scrollToHeader(dir)\" [title]=\"dir.element.nativeElement.textContent\" #anchor>\n                {{ dir.element.nativeElement.textContent }}\n            </span>\n        </li>\n    </ul>\n</div>\n<div class=\"content\">\n    <ng-content></ng-content>\n</div>", styles: [":host{display:block}.spy>ul{list-style-type:none;padding-left:0}.spy>ul>li:hover{color:rgba(var(--bs-dark-rgb),var(--bs-text-opacity))!important}.spy>ul>li{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}@media (min-width: 768px){:host{display:grid;grid-template-areas:\"content toc\";grid-template-columns:auto 200px;grid-template-rows:auto;grid-gap:inherit;gap:inherit;grid-area:main}.spy{position:sticky;top:5rem;right:0;z-index:2;height:calc(100vh - 7rem);overflow-y:auto;grid-area:toc}.spy>ul{padding-left:2rem}}.navH2{margin-left:20px}.navH3{margin-left:40px}.navH4{margin-left:60px}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-scrollspy', template: "<div class=\"spy\">\n    <ul class=\"text-muted\">\n        <li *ngFor=\"let dir of directives; let i = index\">\n            <span [attr.data-index]=\"i\" class=\"cursor-pointer\" [ngClass]=\"'nav' + dir.element.nativeElement.tagName\" [class.fw-bold]=\"activeDirective?.element === dir.element\" (click)=\"scrollToHeader(dir)\" [title]=\"dir.element.nativeElement.textContent\" #anchor>\n                {{ dir.element.nativeElement.textContent }}\n            </span>\n        </li>\n    </ul>\n</div>\n<div class=\"content\">\n    <ng-content></ng-content>\n</div>", styles: [":host{display:block}.spy>ul{list-style-type:none;padding-left:0}.spy>ul>li:hover{color:rgba(var(--bs-dark-rgb),var(--bs-text-opacity))!important}.spy>ul>li{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}@media (min-width: 768px){:host{display:grid;grid-template-areas:\"content toc\";grid-template-columns:auto 200px;grid-template-rows:auto;grid-gap:inherit;gap:inherit;grid-area:main}.spy{position:sticky;top:5rem;right:0;z-index:2;height:calc(100vh - 7rem);overflow-y:auto;grid-area:toc}.spy>ul{padding-left:2rem}}.navH2{margin-left:20px}.navH3{margin-left:40px}.navH4{margin-left:60px}\n"] }]
        }], ctorParameters: function () { return [{ type: BsScrollOffsetService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { directives: [{
                type: ContentChildren,
                args: [BsScrollspyDirective, { descendants: true }]
            }], anchors: [{
                type: ViewChildren,
                args: ['anchor']
            }], onWindowScroll: [{
                type: HostListener,
                args: ['window:scroll', ['$event']]
            }] } });

class BsScrollspyModule {
}
BsScrollspyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsScrollspyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyModule, declarations: [BsScrollspyComponent,
        BsScrollspyDirective], imports: [CommonModule], exports: [BsScrollspyComponent,
        BsScrollspyDirective] });
BsScrollspyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsScrollspyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsScrollspyComponent,
                        BsScrollspyDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsScrollspyComponent,
                        BsScrollspyDirective
                    ]
                }]
        }] });

class BsInListPipe {
    transform(items, parameter) {
        return items.some(item => item.id === parameter);
    }
}
BsInListPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsInListPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListPipe, name: "inList" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'inList'
                }]
        }] });

class BsSelect2Component {
    constructor() {
        this.isOpen = false;
        this.suggestions$ = new BehaviorSubject([]);
        this.isLoading$ = new BehaviorSubject(false);
        this.hostWidth$ = new BehaviorSubject(200);
        this.searchterm = '';
        this.suggestions = [];
        this.provideSuggestions = new EventEmitter();
        this.selectedItems = [];
        this.isFocused = false;
        this.charWidth = 10;
        this.searchWidth = 20;
    }
    ngAfterViewInit() {
        this.onResize();
    }
    onProvideSuggestions(value) {
        this.searchWidth = this.charWidth * (this.searchterm.length + 2);
        if (value === '') {
            this.isOpen = false;
            this.suggestions$.next([]);
        }
        else {
            this.isLoading$.next(true);
            this.isOpen = true;
            this.provideSuggestions.emit(value);
        }
    }
    onSuggestionClicked(suggestion) {
        this.searchterm = '';
        this.isOpen = false;
        const existing = this.selectedItems.find((value, index) => value.id === suggestion.id);
        if (existing === undefined) {
            this.selectedItems.push(suggestion);
        }
        else {
            this.selectedItems.splice(this.selectedItems.indexOf(existing), 1);
        }
        this.searchBox.nativeElement.focus();
    }
    onRemoveItem(item, event) {
        event.stopPropagation();
        this.selectedItems.splice(this.selectedItems.indexOf(item), 1);
        this.focus();
    }
    ngOnInit() {
    }
    onResize() {
        this.hostWidth$.next(this.itemsBox.nativeElement.offsetWidth);
    }
    focus() {
        this.searchBox.nativeElement.focus();
    }
}
BsSelect2Component.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Component, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsSelect2Component.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsSelect2Component, selector: "bs-select2", inputs: { searchterm: "searchterm", suggestions: "suggestions", selectedItems: "selectedItems" }, outputs: { provideSuggestions: "provideSuggestions" }, host: { listeners: { "window:resize": "onResize()", "click": "focus()" }, properties: { "class.focus": "this.isFocused" } }, viewQueries: [{ propertyName: "searchBox", first: true, predicate: ["searchBox"], descendants: true }, { propertyName: "itemsBox", first: true, predicate: ["itemsBox"], descendants: true }, { propertyName: "defaultItemTemplate", first: true, predicate: ["defaultItemTemplate"], descendants: true, static: true }], ngImport: i0, template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\" #itemsBox class=\"items-box\">\n    <ng-container *ngFor=\"let item of selectedItems\">\n        <ng-container *ngTemplateOutlet=\"itemTemplate ?? defaultItemTemplate; context: { item: item, select2: this }\"></ng-container>\n    </ng-container>\n\n    <input type=\"text\" autocomplete=\"off\"\n        [(ngModel)]=\"searchterm\"\n        (ngModelChange)=\"onProvideSuggestions($event)\"\n        (focus)=\"isFocused=true\"\n        (blur)=\"isFocused=false\"\n        [style.width.px]=\"searchWidth\"\n        #searchBox />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static p-0\" [style.width.px]=\"hostWidth$ | async\">\n            <li *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [class.selected]=\"selectedItems | inList:suggestion.id\">{{ suggestion.text }}</li>\n        </ul>\n    </div>\n</div>\n\n<ng-template #defaultItemTemplate let-item=\"item\" let-select2=\"select2\">\n    <span class=\"select2-item\">\n        <span (click)=\"select2.onRemoveItem(item,$event)\">\u00D7</span>\n        {{ item.text }}\n    </span>\n</ng-template>\n", styles: [".items-box{display:block;position:relative;width:100%;min-height:38px;padding:0 5px 3px;cursor:text;border:1px solid #ccc}.items-box .select2-item{display:inline-block;background-color:#e4e4e4;color:#1a1a1a;border:1px solid #aaa;border-radius:4px;margin-top:5px;margin-right:5px;padding:0 5px;cursor:default;user-select:none;-webkit-user-select:none}.items-box .select2-item>span{cursor:pointer;color:#999}.items-box .select2-item>span:hover{color:#333}.items-box input{border:none;outline:0;margin:5px 0 2px;background:none}:host{display:block;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}ul{max-height:200px;overflow-y:auto}ul>li{padding:10px;cursor:pointer}ul>li.selected{background:#ddd}ul>li:hover{color:#fff;background-color:#5897fb}\n"], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "isOpen"], outputs: ["isOpenChange"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }], pipes: { "async": i1.AsyncPipe, "inList": BsInListPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Component, decorators: [{
            type: Component,
            args: [{ selector: 'bs-select2', template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\" #itemsBox class=\"items-box\">\n    <ng-container *ngFor=\"let item of selectedItems\">\n        <ng-container *ngTemplateOutlet=\"itemTemplate ?? defaultItemTemplate; context: { item: item, select2: this }\"></ng-container>\n    </ng-container>\n\n    <input type=\"text\" autocomplete=\"off\"\n        [(ngModel)]=\"searchterm\"\n        (ngModelChange)=\"onProvideSuggestions($event)\"\n        (focus)=\"isFocused=true\"\n        (blur)=\"isFocused=false\"\n        [style.width.px]=\"searchWidth\"\n        #searchBox />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static p-0\" [style.width.px]=\"hostWidth$ | async\">\n            <li *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [class.selected]=\"selectedItems | inList:suggestion.id\">{{ suggestion.text }}</li>\n        </ul>\n    </div>\n</div>\n\n<ng-template #defaultItemTemplate let-item=\"item\" let-select2=\"select2\">\n    <span class=\"select2-item\">\n        <span (click)=\"select2.onRemoveItem(item,$event)\">\u00D7</span>\n        {{ item.text }}\n    </span>\n</ng-template>\n", styles: [".items-box{display:block;position:relative;width:100%;min-height:38px;padding:0 5px 3px;cursor:text;border:1px solid #ccc}.items-box .select2-item{display:inline-block;background-color:#e4e4e4;color:#1a1a1a;border:1px solid #aaa;border-radius:4px;margin-top:5px;margin-right:5px;padding:0 5px;cursor:default;user-select:none;-webkit-user-select:none}.items-box .select2-item>span{cursor:pointer;color:#999}.items-box .select2-item>span:hover{color:#333}.items-box input{border:none;outline:0;margin:5px 0 2px;background:none}:host{display:block;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host.focus{color:#495057;background-color:#fff;border-color:#80bdff!important;outline:0;box-shadow:0 0 0 .2rem #007bff40}ul{max-height:200px;overflow-y:auto}ul>li{padding:10px;cursor:pointer}ul>li.selected{background:#ddd}ul>li:hover{color:#fff;background-color:#5897fb}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { searchBox: [{
                type: ViewChild,
                args: ['searchBox']
            }], itemsBox: [{
                type: ViewChild,
                args: ['itemsBox']
            }], searchterm: [{
                type: Input
            }], suggestions: [{
                type: Input
            }], provideSuggestions: [{
                type: Output
            }], selectedItems: [{
                type: Input
            }], isFocused: [{
                type: HostBinding,
                args: ['class.focus']
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }], focus: [{
                type: HostListener,
                args: ['click']
            }], defaultItemTemplate: [{
                type: ViewChild,
                args: ['defaultItemTemplate', { static: true }]
            }] } });

class BsItemTemplateDirective {
    constructor(select2component, templateRef) {
        this.select2component = select2component;
        console.log('template', templateRef);
        this.select2component.itemTemplate = templateRef;
    }
}
BsItemTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsItemTemplateDirective, deps: [{ token: BsSelect2Component }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
BsItemTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsItemTemplateDirective, selector: "[bsItemTemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsItemTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsItemTemplate]'
                }]
        }], ctorParameters: function () { return [{ type: BsSelect2Component }, { type: i0.TemplateRef }]; } });

class BsInListModule {
}
BsInListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsInListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListModule, declarations: [BsInListPipe], imports: [CommonModule], exports: [BsInListPipe] });
BsInListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsInListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsInListPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsInListPipe
                    ]
                }]
        }] });

class BsSelect2Module {
}
BsSelect2Module.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Module, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsSelect2Module.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Module, declarations: [BsSelect2Component,
        BsItemTemplateDirective], imports: [CommonModule,
        FormsModule,
        BsDropdownModule,
        BsInListModule], exports: [BsSelect2Component,
        BsItemTemplateDirective] });
BsSelect2Module.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Module, imports: [[
            CommonModule,
            FormsModule,
            BsDropdownModule,
            BsInListModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSelect2Module, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSelect2Component,
                        BsItemTemplateDirective
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        BsDropdownModule,
                        BsInListModule
                    ],
                    exports: [
                        BsSelect2Component,
                        BsItemTemplateDirective
                    ]
                }]
        }] });

const SNACKBAR_CONTENT = new InjectionToken('SnackbarContent');

class BsSnackbarComponent {
    constructor(content) {
        this.displayBlock = true;
        this.width100 = true;
        this.instance = null;
        //#region Monitor @slideUpDown hooks
        this.animationState = '';
        this.animationStateChanged = new EventEmitter();
        this.content = content;
    }
    onAnimationChanged(event) {
        this.animationStateChanged.emit(event);
    }
}
BsSnackbarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarComponent, deps: [{ token: SNACKBAR_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsSnackbarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsSnackbarComponent, selector: "bs-snackbar", host: { properties: { "class.d-block": "this.displayBlock", "class.w-100": "this.width100" } }, ngImport: i0, template: "<div [@slideUpDown]=\"animationState\"\n     (@slideUpDown.start)=\"onAnimationChanged($event)\"\n     (@slideUpDown.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [":host{background:#232323;color:rgba(var(--bs-light-rgb))}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [SlideUpDownAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-snackbar', animations: [SlideUpDownAnimation], template: "<div [@slideUpDown]=\"animationState\"\n     (@slideUpDown.start)=\"onAnimationChanged($event)\"\n     (@slideUpDown.done)=\"onAnimationChanged($event)\">\n\n    <ng-container *ngTemplateOutlet=\"content; context: { $implicit: this }\" ></ng-container>\n</div>", styles: [":host{background:#232323;color:rgba(var(--bs-light-rgb))}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [SNACKBAR_CONTENT]
                }] }]; }, propDecorators: { displayBlock: [{
                type: HostBinding,
                args: ['class.d-block']
            }], width100: [{
                type: HostBinding,
                args: ['class.w-100']
            }] } });

class BsSnackbarService {
    constructor(overlay, parentInjector, componentFactoryResolver) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
        this.componentFactoryResolver = componentFactoryResolver;
    }
    show(template) {
        const injector = Injector.create({
            providers: [{ provide: SNACKBAR_CONTENT, useValue: template }],
            parent: this.parentInjector
        });
        const portal = new ComponentPortal(BsSnackbarComponent, null, injector, this.componentFactoryResolver);
        const overlayRef = this.overlay.create({
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: this.overlay.position()
                .global().centerHorizontally().bottom('0'),
            width: '100%'
        });
        const componentInstance = overlayRef.attach(portal);
        // componentInstance.
        componentInstance.instance['instance'] = {
            component: componentInstance,
            overlay: overlayRef
        };
        return componentInstance.instance;
    }
    hide(snackbar) {
        snackbar.animationStateChanged.pipe(filter(ev => ev.phaseName === 'done' && ev.toState === 'void'), take(1)).subscribe(() => {
            snackbar['instance']?.overlay.dispose();
        });
        snackbar.animationState = 'void';
    }
}
BsSnackbarService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarService, deps: [{ token: i1$1.Overlay }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Injectable });
BsSnackbarService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; } });

class BsSnackbarCloseDirective {
    constructor(snackbarService) {
        this.snackbarService = snackbarService;
    }
    onClick() {
        this.snackbarService.hide(this.bsSnackbarClose);
    }
}
BsSnackbarCloseDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarCloseDirective, deps: [{ token: BsSnackbarService }], target: i0.ɵɵFactoryTarget.Directive });
BsSnackbarCloseDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsSnackbarCloseDirective, selector: "[bsSnackbarClose]", inputs: { bsSnackbarClose: "bsSnackbarClose" }, host: { listeners: { "click": "onClick()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarCloseDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsSnackbarClose]'
                }]
        }], ctorParameters: function () { return [{ type: BsSnackbarService }]; }, propDecorators: { bsSnackbarClose: [{
                type: Input
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class BsSnackbarModule {
}
BsSnackbarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsSnackbarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarModule, declarations: [BsSnackbarComponent,
        BsSnackbarCloseDirective], imports: [CommonModule], exports: [BsSnackbarComponent,
        BsSnackbarCloseDirective] });
BsSnackbarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarModule, providers: [
    // { provide: BsSnackbarComponent, useExisting: forwardRef(() => BsSnackbarComponent) }
    // { provide: BsSnackbarComponent, useClass: BsSnackbarComponent }
    ], imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsSnackbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSnackbarComponent,
                        BsSnackbarCloseDirective
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsSnackbarComponent,
                        BsSnackbarCloseDirective
                    ],
                    providers: [
                    // { provide: BsSnackbarComponent, useExisting: forwardRef(() => BsSnackbarComponent) }
                    // { provide: BsSnackbarComponent, useClass: BsSnackbarComponent }
                    ]
                }]
        }] });

class BsTabPageComponent {
    constructor(tabControl) {
        this.disabled = false;
        this.tabControl = tabControl;
    }
    ngOnInit() {
    }
}
BsTabPageComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabPageComponent, deps: [{ token: BsTabControlComponent }], target: i0.ɵɵFactoryTarget.Component });
BsTabPageComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsTabPageComponent, selector: "bs-tab-page", inputs: { disabled: "disabled" }, queries: [{ propertyName: "headerTemplate", first: true, predicate: TemplateRef, descendants: true }], ngImport: i0, template: "<ng-content *ngIf=\"tabControl.activeTab === this\"></ng-content>", styles: [""], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabPageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tab-page', template: "<ng-content *ngIf=\"tabControl.activeTab === this\"></ng-content>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: BsTabControlComponent }]; }, propDecorators: { headerTemplate: [{
                type: ContentChild,
                args: [TemplateRef]
            }], disabled: [{
                type: Input
            }] } });

class BsTabControlComponent {
    constructor() {
        this.activeTab = null;
    }
    ngOnInit() {
    }
    setActiveTab(tab) {
        if (!tab.disabled) {
            this.activeTab = tab;
        }
        return false;
    }
}
BsTabControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsTabControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsTabControlComponent, selector: "bs-tab-control", queries: [{ propertyName: "tabPages", predicate: BsTabPageComponent }], ngImport: i0, template: "<ul class=\"nav nav-tabs\">\n  <ng-container *ngFor=\"let tab of tabPages\">\n    <li class=\"nav-item\" (click)=\"setActiveTab(tab)\" *ngIf=\"!!tab.headerTemplate\">\n      <a class=\"nav-link\" [class.active]=\"activeTab === tab\" [class.disabled]=\"tab.disabled\" [attr.aria-current]=\"activeTab === tab ? 'page' : null\" [attr.aria-disabled]=\"tab.disabled\" href=\"\">\n        <ng-container [ngTemplateOutlet]=\"tab.headerTemplate\"></ng-container>\n      </a>\n    </li>\n  </ng-container>\n</ul>\n<!-- <div class=\"container\"> -->\n  <ng-content></ng-content>\n<!-- </div> -->", styles: [""], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tab-control', template: "<ul class=\"nav nav-tabs\">\n  <ng-container *ngFor=\"let tab of tabPages\">\n    <li class=\"nav-item\" (click)=\"setActiveTab(tab)\" *ngIf=\"!!tab.headerTemplate\">\n      <a class=\"nav-link\" [class.active]=\"activeTab === tab\" [class.disabled]=\"tab.disabled\" [attr.aria-current]=\"activeTab === tab ? 'page' : null\" [attr.aria-disabled]=\"tab.disabled\" href=\"\">\n        <ng-container [ngTemplateOutlet]=\"tab.headerTemplate\"></ng-container>\n      </a>\n    </li>\n  </ng-container>\n</ul>\n<!-- <div class=\"container\"> -->\n  <ng-content></ng-content>\n<!-- </div> -->", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { tabPages: [{
                type: ContentChildren,
                args: [BsTabPageComponent]
            }] } });

class BsTabControlModule {
}
BsTabControlModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTabControlModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlModule, declarations: [BsTabControlComponent,
        BsTabPageComponent], imports: [CommonModule], exports: [BsTabControlComponent,
        BsTabPageComponent] });
BsTabControlModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTabControlModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTabControlComponent,
                        BsTabPageComponent,
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsTabControlComponent,
                        BsTabPageComponent,
                    ]
                }]
        }] });

class BsToggleButtonComponent {
    constructor() {
        this.disableAnimations = true;
        //#region isToggled
        this._isToggled = false;
        this.isToggledChange = new EventEmitter();
        //#endregion
        this.offColor = '#CCCCCC';
        this.onColor = '#2196F3';
        this.round = true;
    }
    ngAfterViewInit() {
        this.disableAnimations = false;
    }
    get isToggled() {
        return this._isToggled;
    }
    set isToggled(value) {
        this._isToggled = value;
        this.isToggledChange.emit(this._isToggled);
    }
}
BsToggleButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsToggleButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsToggleButtonComponent, selector: "bs-toggle-button", inputs: { isToggled: "isToggled", offColor: "offColor", onColor: "onColor", round: "round" }, outputs: { isToggledChange: "isToggledChange" }, ngImport: i0, template: "<label (click)=\"isToggled = !isToggled\" class=\"switch\" [class.checked]=\"isToggled\">\n    <span class=\"slider\" [class.round]=\"round\" [@colorTransition]=\"{ value: isToggled ? 'color2' : 'color1', params: { color1: offColor, color2: onColor, 'duration': '.4s' } }\"></span>\n</label>", styles: [".switch{position:relative;display:inline-block;width:30px;height:17px}.switch>.slider{position:absolute;cursor:pointer;top:0;left:0;right:0;bottom:0;transition:transform .4s}.switch>.slider.round{border-radius:8.5px}.switch>.slider.round:before{border-radius:50%}.switch>.slider:before{position:absolute;content:\"\";height:13px;width:13px;left:2px;top:0;bottom:0;margin:auto 0;background-color:#fff;transition:transform .4s}.switch.checked .slider:before{transform:translate(13px)}\n"], animations: [ColorTransitionAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-toggle-button', animations: [ColorTransitionAnimation], template: "<label (click)=\"isToggled = !isToggled\" class=\"switch\" [class.checked]=\"isToggled\">\n    <span class=\"slider\" [class.round]=\"round\" [@colorTransition]=\"{ value: isToggled ? 'color2' : 'color1', params: { color1: offColor, color2: onColor, 'duration': '.4s' } }\"></span>\n</label>", styles: [".switch{position:relative;display:inline-block;width:30px;height:17px}.switch>.slider{position:absolute;cursor:pointer;top:0;left:0;right:0;bottom:0;transition:transform .4s}.switch>.slider.round{border-radius:8.5px}.switch>.slider.round:before{border-radius:50%}.switch>.slider:before{position:absolute;content:\"\";height:13px;width:13px;left:2px;top:0;bottom:0;margin:auto 0;background-color:#fff;transition:transform .4s}.switch.checked .slider:before{transform:translate(13px)}\n"] }]
        }], propDecorators: { isToggledChange: [{
                type: Output
            }], isToggled: [{
                type: Input
            }], offColor: [{
                type: Input
            }], onColor: [{
                type: Input
            }], round: [{
                type: Input
            }] } });

class BsToggleButtonModule {
}
BsToggleButtonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsToggleButtonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonModule, declarations: [BsToggleButtonComponent], imports: [CommonModule], exports: [BsToggleButtonComponent] });
BsToggleButtonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsToggleButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsToggleButtonComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsToggleButtonComponent
                    ]
                }]
        }] });

const TOOLTIP_CONTENT = new InjectionToken('TooltipContent');

class BsTooltipComponent {
    constructor(content) {
        this.positions = Position;
        this.position = Position.bottom;
        this.template = content;
    }
}
BsTooltipComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipComponent, deps: [{ token: TOOLTIP_CONTENT }], target: i0.ɵɵFactoryTarget.Component });
BsTooltipComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsTooltipComponent, selector: "bs-tooltip", inputs: { position: "position" }, ngImport: i0, template: "<div [@fadeInOut] class=\"tooltip position-relative show\"\n    [class.bs-tooltip-bottom]=\"position === positions.bottom\"\n    [class.bs-tooltip-top]=\"position === positions.top\"\n    [class.bs-tooltip-start]=\"position === positions.left\"\n    [class.bs-tooltip-end]=\"position === positions.right\">\n    <div class=\"tooltip-arrow\"></div>\n    <div class=\"tooltip-inner\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n</div>\n", styles: [".tooltip.bs-tooltip-bottom .tooltip-arrow,.tooltip.bs-tooltip-top .tooltip-arrow{left:50%;transform:translate(-50%)}.tooltip.bs-tooltip-start .tooltip-arrow,.tooltip.bs-tooltip-end .tooltip-arrow{top:50%;transform:translateY(-50%)}\n"], directives: [{ type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [FadeInOutAnimation] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-tooltip', animations: [FadeInOutAnimation], template: "<div [@fadeInOut] class=\"tooltip position-relative show\"\n    [class.bs-tooltip-bottom]=\"position === positions.bottom\"\n    [class.bs-tooltip-top]=\"position === positions.top\"\n    [class.bs-tooltip-start]=\"position === positions.left\"\n    [class.bs-tooltip-end]=\"position === positions.right\">\n    <div class=\"tooltip-arrow\"></div>\n    <div class=\"tooltip-inner\">\n        <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n</div>\n", styles: [".tooltip.bs-tooltip-bottom .tooltip-arrow,.tooltip.bs-tooltip-top .tooltip-arrow{left:50%;transform:translate(-50%)}.tooltip.bs-tooltip-start .tooltip-arrow,.tooltip.bs-tooltip-end .tooltip-arrow{top:50%;transform:translateY(-50%)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TOOLTIP_CONTENT]
                }] }]; }, propDecorators: { position: [{
                type: Input
            }] } });

class BsTooltipDirective {
    constructor(overlay, templateRef, componentFactoryResolver, parentInjector, parent) {
        this.overlay = overlay;
        this.templateRef = templateRef;
        this.parentInjector = parentInjector;
        this.parent = parent;
        this.bsTooltip = Position.bottom;
        this.overlayRef = null;
        this.injector = Injector.create({
            providers: [{ provide: TOOLTIP_CONTENT, useValue: this.templateRef }],
            parent: this.parentInjector
        });
        this.portal = new ComponentPortal(BsTooltipComponent, null, this.injector, componentFactoryResolver);
        parent.nativeElement.onmouseenter = () => {
            this.showTooltip();
        };
        parent.nativeElement.onmouseleave = () => {
            this.hideTooltip();
        };
    }
    showTooltip() {
        const positions = [];
        switch (this.bsTooltip) {
            case Position.bottom:
                {
                    positions.push({
                        originX: "center",
                        originY: "bottom",
                        overlayX: "center",
                        overlayY: "top"
                    });
                }
                break;
            case Position.top:
                {
                    positions.push({
                        originX: "center",
                        originY: "top",
                        overlayX: "center",
                        overlayY: "bottom"
                    });
                }
                break;
            case Position.left:
                {
                    positions.push({
                        originX: "start",
                        originY: "center",
                        overlayX: "end",
                        overlayY: "center",
                    });
                }
                break;
            case Position.right:
                {
                    positions.push({
                        originX: "end",
                        originY: "center",
                        overlayX: "start",
                        overlayY: "center"
                    });
                }
                break;
        }
        this.overlayRef = this.overlay.create({
            scrollStrategy: this.overlay.scrollStrategies.reposition(),
            positionStrategy: this.overlay.position()
                .flexibleConnectedTo(this.parent)
                .withPositions(positions),
        });
        const component = this.overlayRef.attach(this.portal);
        component.instance.position = this.bsTooltip;
    }
    hideTooltip() {
        if (this.overlayRef) {
            this.overlayRef.detach();
            this.overlayRef.dispose();
            this.overlayRef = null;
        }
    }
}
BsTooltipDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipDirective, deps: [{ token: i1$1.Overlay }, { token: i0.TemplateRef }, { token: i0.ComponentFactoryResolver }, { token: i0.Injector }, { token: i0.ElementRef, host: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.Directive });
BsTooltipDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.1.1", type: BsTooltipDirective, selector: "*[bsTooltip]", inputs: { bsTooltip: "bsTooltip" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '*[bsTooltip]'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.Overlay }, { type: i0.TemplateRef }, { type: i0.ComponentFactoryResolver }, { type: i0.Injector }, { type: i0.ElementRef, decorators: [{
                    type: Host
                }, {
                    type: SkipSelf
                }] }]; }, propDecorators: { bsTooltip: [{
                type: Input
            }] } });

class BsTooltipModule {
}
BsTooltipModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTooltipModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipModule, declarations: [BsTooltipDirective,
        BsTooltipComponent], imports: [CommonModule], exports: [BsTooltipDirective] });
BsTooltipModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTooltipModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTooltipDirective,
                        BsTooltipComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsTooltipDirective
                    ]
                }]
        }] });

class BsTypeaheadComponent {
    constructor() {
        this.isOpen = false;
        this.suggestions$ = new BehaviorSubject([]);
        this.isLoading$ = new BehaviorSubject(false);
        this.hostWidth$ = new BehaviorSubject(200);
        this.destroyed$ = new Subject();
        this.searchterm = '';
        this.isLoadingText = 'Loading...';
        this.noSuggestionsText = 'No suggestions found';
        this.provideSuggestions = new EventEmitter();
        this.suggestionSelected = new EventEmitter();
        this.searchtermChange = new EventEmitter();
        this.submitted = new EventEmitter();
        this.showNoSuggestions$ = this.suggestions$
            .pipe(map(suggestions => suggestions.length === 0));
    }
    ngAfterViewInit() {
        this.onResize();
    }
    onProvideSuggestions(value) {
        this.searchtermChange.emit(value);
        if (value === '') {
            this.isOpen = false;
            this.suggestions$.next([]);
        }
        else {
            this.isLoading$.next(true);
            this.isOpen = true;
            this.provideSuggestions.emit(value);
        }
    }
    set suggestions(value) {
        this.isLoading$.next(false);
        this.suggestions$.next(value);
    }
    suggestionClicked(suggestion) {
        this.searchterm = suggestion.text;
        this.searchtermChange.emit(this.searchterm);
        this.isOpen = false;
        this.suggestionSelected.emit(suggestion);
    }
    onSubmit() {
        this.isOpen = false;
        this.submitted.emit(this.searchterm);
    }
    focus() {
        this.textbox.nativeElement.focus();
    }
    onResize() {
        this.hostWidth$.next(this.textbox.nativeElement.offsetWidth);
    }
}
BsTypeaheadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsTypeaheadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.1", type: BsTypeaheadComponent, selector: "bs-typeahead", inputs: { searchterm: "searchterm", isLoadingText: "isLoadingText", noSuggestionsText: "noSuggestionsText", suggestions: "suggestions" }, outputs: { provideSuggestions: "provideSuggestions", suggestionSelected: "suggestionSelected", searchtermChange: "searchtermChange", submitted: "submitted" }, host: { listeners: { "window:resize": "onResize()" } }, viewQueries: [{ propertyName: "textbox", first: true, predicate: ["textbox"], descendants: true }], ngImport: i0, template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\">\n    <input type=\"text\" class=\"form-control\" #textbox [(ngModel)]=\"searchterm\" (ngModelChange)=\"onProvideSuggestions($event)\" (keyup.enter)=\"onSubmit()\" />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static\" [style.width.px]=\"hostWidth$ | async\">\n            <bs-progress *ngIf=\"isLoading$ | async\" [height]=\"2\" [isIndeterminate]=\"true\"></bs-progress>\n            <li *ngIf=\"isLoading$ | async\">\n                <a class=\"dropdown-item disabled\">{{ isLoadingText }}</a>\n            </li>\n            <ng-container *ngIf=\"(isLoading$ | async) === false\">\n                <li *ngIf=\"showNoSuggestions$ | async\">\n                    <a class=\"dropdown-item disabled\">{{ noSuggestionsText }}</a>\n                </li>\n                <li *ngFor=\"let suggestion of (suggestions$ | async)\" (click)=\"suggestionClicked(suggestion)\">\n                    <a class=\"dropdown-item cursor-pointer\">{{ suggestion.text }}</a>\n                </li>\n            </ng-container>\n        </ul>\n    </div>\n</div>", styles: ["bs-progress{margin-top:-8px;margin-bottom:6px}\n"], components: [{ type: BsProgressComponent, selector: "bs-progress", inputs: ["height", "isIndeterminate"] }], directives: [{ type: BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "isOpen"], outputs: ["isOpenChange"] }, { type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-typeahead', template: "<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [closeOnClickOutside]=\"true\">\n    <input type=\"text\" class=\"form-control\" #textbox [(ngModel)]=\"searchterm\" (ngModelChange)=\"onProvideSuggestions($event)\" (keyup.enter)=\"onSubmit()\" />\n    <div *bsDropdownMenu>\n        <ul class=\"dropdown-menu d-block position-static\" [style.width.px]=\"hostWidth$ | async\">\n            <bs-progress *ngIf=\"isLoading$ | async\" [height]=\"2\" [isIndeterminate]=\"true\"></bs-progress>\n            <li *ngIf=\"isLoading$ | async\">\n                <a class=\"dropdown-item disabled\">{{ isLoadingText }}</a>\n            </li>\n            <ng-container *ngIf=\"(isLoading$ | async) === false\">\n                <li *ngIf=\"showNoSuggestions$ | async\">\n                    <a class=\"dropdown-item disabled\">{{ noSuggestionsText }}</a>\n                </li>\n                <li *ngFor=\"let suggestion of (suggestions$ | async)\" (click)=\"suggestionClicked(suggestion)\">\n                    <a class=\"dropdown-item cursor-pointer\">{{ suggestion.text }}</a>\n                </li>\n            </ng-container>\n        </ul>\n    </div>\n</div>", styles: ["bs-progress{margin-top:-8px;margin-bottom:6px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { textbox: [{
                type: ViewChild,
                args: ['textbox']
            }], searchterm: [{
                type: Input
            }], isLoadingText: [{
                type: Input
            }], noSuggestionsText: [{
                type: Input
            }], provideSuggestions: [{
                type: Output
            }], suggestionSelected: [{
                type: Output
            }], searchtermChange: [{
                type: Output
            }], submitted: [{
                type: Output
            }], suggestions: [{
                type: Input
            }], onResize: [{
                type: HostListener,
                args: ['window:resize']
            }] } });

class BsTypeaheadModule {
}
BsTypeaheadModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsTypeaheadModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadModule, declarations: [BsTypeaheadComponent], imports: [CommonModule,
        FormsModule,
        BsDropdownModule,
        BsProgressBarModule], exports: [BsTypeaheadComponent] });
BsTypeaheadModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadModule, imports: [[
            CommonModule,
            FormsModule,
            BsDropdownModule,
            BsProgressBarModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsTypeaheadModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsTypeaheadComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        BsDropdownModule,
                        BsProgressBarModule
                    ],
                    exports: [
                        BsTypeaheadComponent
                    ]
                }]
        }] });

class BsFontColorPipe {
    transform(color_hex) {
        if (color_hex === undefined || color_hex === null || color_hex.length < 7 || typeof (color_hex) !== 'string') {
            return '#FFFFFF';
        }
        const R_HEX = color_hex.substr(1, 2);
        const G_HEX = color_hex.substr(3, 2);
        const B_HEX = color_hex.substr(5, 2);
        const R_DEC = parseInt(R_HEX, 16);
        const G_DEC = parseInt(G_HEX, 16);
        const B_DEC = parseInt(B_HEX, 16);
        const CONTRAST_HEX = R_DEC * 0.299 + G_DEC * 0.587 + B_DEC * 0.114 > 186 ? '#000000' : '#FFFFFF';
        return CONTRAST_HEX;
    }
}
BsFontColorPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsFontColorPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipe, name: "bsFontColor" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFontColor'
                }]
        }] });

class BsFontColorPipeModule {
}
BsFontColorPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsFontColorPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipeModule, declarations: [BsFontColorPipe], imports: [CommonModule], exports: [BsFontColorPipe] });
BsFontColorPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipeModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.1", ngImport: i0, type: BsFontColorPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFontColorPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFontColorPipe
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsAccordionComponent, BsAccordionModule, BsAccordionTabComponent, BsAccordionTabHeaderComponent, BsAlertCloseComponent, BsAlertComponent, BsAlertModule, BsCalendarComponent, BsCalendarModule, BsCardComponent, BsCardHeaderComponent, BsCardModule, BsCarouselComponent, BsCarouselImageDirective, BsCarouselModule, BsContextMenuDirective, BsContextMenuModule, BsDatatableColumnDirective, BsDatatableComponent, BsDatatableModule, BsDatepickerComponent, BsDatepickerModule, BsDropdownDirective, BsDropdownMenuDirective, BsDropdownModule, BsDropdownToggleDirective, BsFontColorPipe, BsFontColorPipeModule, BsItemTemplateDirective, BsListGroupComponent, BsListGroupItemComponent, BsListGroupModule, BsMultiselectComponent, BsMultiselectModule, BsNavbarComponent, BsNavbarDropdownComponent, BsNavbarItemComponent, BsNavbarModule, BsNavbarNavComponent, BsPaginationComponent, BsPaginationModule, BsProgressBarComponent, BsProgressBarModule, BsProgressComponent, BsRowTemplateDirective, BsScrollspyComponent, BsScrollspyDirective, BsScrollspyModule, BsSelect2Component, BsSelect2Module, BsSnackbarCloseDirective, BsSnackbarComponent, BsSnackbarModule, BsSnackbarService, BsTabControlComponent, BsTabControlModule, BsTabPageComponent, BsToggleButtonComponent, BsToggleButtonModule, BsTooltipDirective, BsTooltipModule, BsTypeaheadComponent, BsTypeaheadModule, Color, DatatableSettings, DropdownToggleDirective, NavLinkDirective, NavbarContentDirective, Position };
//# sourceMappingURL=mintplayer-ng-bootstrap.mjs.map
